////////////////////////////////////////////////////////////////////////////////
//
// Proyecto Medusa v3.0
//
//////////////////////////////////// INFO //////////////////////////////////////
//
//  Nombre del programa : Medusa.exe
//  Fecha               : Septiembre del 2003.
//  Componentes         : DOA 3.4.6.4, SynEdit 1.1 (CVS).
//  Version compilador  : Delphi 6.0 Enterprise.
//  Descripcin         : Un cliente avanzado de Oracle
//  Autor               : Albert Philippe De La Fuente Vigliotti.
//  Tutor               : Jos Galindo Gmez.
//
////////////////////////////////////////////////////////////////////////////////

unit UCabecerasPlantillas;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, Buttons;

type
  TFrmCabeceraPlantilla = class(TForm)
    Panel1: TPanel;
    EdtNombre: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    EdtDescripcion: TEdit;
    BitBtnCancelar: TBitBtn;
    BitBtnOk: TBitBtn;
    procedure FormActivate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
  public
    { Public declarations }
    ModalResult : Integer;
  end;

var
  FrmCabeceraPlantilla: TFrmCabeceraPlantilla;

implementation

uses UPrincipal, UEditor, UConfiguracion, UGlobal;

{$R *.dfm}

procedure TFrmCabeceraPlantilla.FormActivate(Sender: TObject);
begin
  try
    ActiveControl := EdtNombre;  
    CargarEstadoForm(Self);   // Esto es por si se ejecuta desde CD...
  except
  end;
end;

procedure TFrmCabeceraPlantilla.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  try
    GuardarEstadoForm(Self);
  except
  end;  
end;

end.

// 72
