////////////////////////////////////////////////////////////////////////////////
//
// Proyecto Medusa v3.0
//
//////////////////////////////////// INFO //////////////////////////////////////
//
//  Nombre del programa : Medusa.exe
//  Fecha               : Septiembre del 2003.
//  Componentes         : DOA 3.4.6.4, SynEdit 1.1 (CVS).
//  Version compilador  : Delphi 6.0 Enterprise.
//  Descripcin         : Un cliente avanzado de Oracle
//  Autor               : Albert Philippe De La Fuente Vigliotti.
//  Tutor               : Jos Galindo Gmez.
//
////////////////////////////////////////////////////////////////////////////////

unit UConfiguracion;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, StdCtrls, Spin, ExtCtrls, Buttons, IniFiles, CheckLst,
  ActnList, StdActns, SynEdit, Menus, ImgList, SynEditHighlighter;

type
  TFrmConfiguracion = class(TForm)
    PageControl: TPageControl;
    TbShtEditor: TTabSheet;
    TbShtSintaxis: TTabSheet;
    ChkBxRealzarSintaxis: TCheckBox;
    GroupBox1: TGroupBox;
    ChkBxNumLineas: TCheckBox;
    LblDigitos: TLabel;
    SpnEdtDigitos: TSpinEdit;
    TbShtPrevImp: TTabSheet;
    SpnEdtGutter: TSpinEdit;
    LblGutter: TLabel;
    ChkBxMargen: TCheckBox;
    SpnEdtMargen: TSpinEdit;
    LblMargen: TLabel;
    ChkBxGutter: TCheckBox;
    Bevel2: TBevel;
    GroupBox2: TGroupBox;
    ChkBxHome: TCheckBox;
    Label2: TLabel;
    SpnEdtTab: TSpinEdit;
    Label4: TLabel;
    SpnEdtUndo: TSpinEdit;
    Bevel3: TBevel;
    ChkBxTab: TCheckBox;
    ShpBgComentarios: TShape;
    LblComentarios: TLabel;
    Bevel4: TBevel;
    Label5: TLabel;
    Label6: TLabel;
    ShpFgComentarios: TShape;
    Label7: TLabel;
    Bevel5: TBevel;
    Bevel6: TBevel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Bevel7: TBevel;
    Label11: TLabel;
    ChkLstBx1: TCheckListBox;
    LblTipos: TLabel;
    ShpBgTipos: TShape;
    ShpFgTipos: TShape;
    LblPaquetes: TLabel;
    ShpBgPaquetes: TShape;
    ShpFgPaquetes: TShape;
    LblExcepciones: TLabel;
    ShpBgExcepciones: TShape;
    ShpFgExcepciones: TShape;
    LblFunciones: TLabel;
    ShpBgFunciones: TShape;
    ShpFgFunciones: TShape;
    Label24: TLabel;
    Shape12: TShape;
    Shape13: TShape;
    LblIdentificadores: TLabel;
    ShpBgIdentificadores: TShape;
    ShpFgIdentificadores: TShape;
    LblKey: TLabel;
    ShpBgKey: TShape;
    ShpFgKey: TShape;
    LblNumeros: TLabel;
    ShpBgNumeros: TShape;
    ShpFgNumeros: TShape;
    LblPLSQL: TLabel;
    LblEspacios: TLabel;
    LblSQLPlus: TLabel;
    LblStrings: TLabel;
    LblSimbolos: TLabel;
    LblTablas: TLabel;
    LblVariables: TLabel;
    ShpBgVariables: TShape;
    ShpFgVariables: TShape;
    ShpFgTablas: TShape;
    ShpBgTablas: TShape;
    ShpBgSimbolos: TShape;
    ShpFgSimbolos: TShape;
    ShpFgStrings: TShape;
    ShpBgStrings: TShape;
    ShpBgSQLPlus: TShape;
    ShpFgSQLPlus: TShape;
    ShpBgEspacios: TShape;
    ShpFgEspacios: TShape;
    ShpFgPLSQL: TShape;
    ShpBgPLSQL: TShape;
    Label28: TLabel;
    Label29: TLabel;
    Bevel8: TBevel;
    Label30: TLabel;
    Bevel9: TBevel;
    Bevel10: TBevel;
    Bevel11: TBevel;
    Label31: TLabel;
    Label32: TLabel;
    Label33: TLabel;
    Label34: TLabel;
    ChkLstBx2: TCheckListBox;
    Bevel12: TBevel;
    ColorDialog: TColorDialog;
    ChkBxEsquemasPredefinidos: TCheckBox;
    CmbBxEsquemas: TComboBox;
    ChkBxImpresionBlancoNegro: TCheckBox;
    ChkBxRealzarSintaxisPrevisualizacionImpresion: TCheckBox;
    EdtUsuario: TEdit;
    Label3: TLabel;
    ChkBxEnumerarLineas: TCheckBox;
    GroupBox3: TGroupBox;
    SpnEdtIzquierdo: TSpinEdit;
    SpnEdtSuperior: TSpinEdit;
    SpnEdtDerecho: TSpinEdit;
    SpnEdtInferior: TSpinEdit;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    ChkBxMostrarPiePagina: TCheckBox;
    LblPiePagina1: TLabel;
    SpnEdtPiePagina: TSpinEdit;
    LblPiePagina2: TLabel;
    TbShtOracle: TTabSheet;
    CheckBox1: TCheckBox;
    TbShtFavoritos: TTabSheet;
    TrVwConsultaDD: TTreeView;
    SpdBtnNuevoItemFav: TSpeedButton;
    SpdBtnNuevoSubItemFav: TSpeedButton;
    SpdBtnEliminarFav: TSpeedButton;
    EdtTituloConsultaDD: TEdit;
    Label18: TLabel;
    LblSentencia: TLabel;
    OpenDialog: TOpenDialog;
    TbShtProgramas: TTabSheet;
    SpdBtnPrograma1: TSpeedButton;
    LblPrograma1: TLabel;
    ImgIcono: TImage;
    EdtArgs1: TEdit;
    Label20: TLabel;
    SpdBtnPrograma2: TSpeedButton;
    LblPrograma2: TLabel;
    EdtArgs2: TEdit;
    Label22: TLabel;
    SpdBtnPrograma3: TSpeedButton;
    LblPrograma3: TLabel;
    EdtArgs3: TEdit;
    Label25: TLabel;
    SpdBtnPrograma4: TSpeedButton;
    LblPrograma4: TLabel;
    EdtArgs4: TEdit;
    Label27: TLabel;
    SpdBtnPrograma5: TSpeedButton;
    LblPrograma5: TLabel;
    EdtArgs5: TEdit;
    Label36: TLabel;
    ChkBxConectarAutomaticamenteSesion: TCheckBox;
    TbShtPlantillas: TTabSheet;
    GroupBox4: TGroupBox;
    SynEditCodigoPlantillas: TSynEdit;
    LstVwTitulosPlantillas: TListView;
    Label1: TLabel;
    Label37: TLabel;
    SpdBtnAniadirPlantilla: TSpeedButton;
    SpdBtnEditarPlantilla: TSpeedButton;
    SpdBtnEliminarPlantilla: TSpeedButton;
    ActionList1: TActionList;
    ActAbrirPrograma: TFileOpen;
    BitBtnCancelar: TBitBtn;
    BitBtnOk: TBitBtn;
    SpnEdtBuffer: TSpinEdit;
    Label38: TLabel;
    SynEdit: TSynEdit;
    SpdBtnAplicarFav: TSpeedButton;
    ImageList: TImageList;
    SpdBtnExpandirFav: TSpeedButton;
    SpdBtnContraerFav: TSpeedButton;
    GroupBox5: TGroupBox;
    SpdBtnDocumentacion: TSpeedButton;
    LblDocumentacion: TLabel;
    GroupBox6: TGroupBox;
    ChkBxConectarAutomaticamente: TCheckBox;
    LblLogin: TLabel;
    LblPassword: TLabel;
    EdtPassword: TEdit;
    EdtLogin: TEdit;
    SpdBtnCambiarFav: TSpeedButton;
    SpdBtnNuevoDirFav: TSpeedButton;
    SpdBtnNuevoSubDirFav: TSpeedButton;
    RdGrpFormaConexion: TRadioGroup;
    ChkBxGuardarIni: TCheckBox;
    SpdBtnLimpiar: TSpeedButton;
    Label16: TLabel;
    EdtNombre1: TEdit;
    Label17: TLabel;
    EdtNombre2: TEdit;
    Label19: TLabel;
    EdtNombre3: TEdit;
    Label39: TLabel;
    EdtNombre4: TEdit;
    Label40: TLabel;
    EdtNombre5: TEdit;
    procedure ChkBxNumLineasClick(Sender: TObject);
    procedure ChkBxMargenClick(Sender: TObject);
    procedure ChkBxGutterClick(Sender: TObject);
    procedure ShpBgComentariosMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure ChkBxEsquemasPredefinidosClick(Sender: TObject);
    procedure ChkBxRealzarSintaxisClick(Sender: TObject);
    procedure Shape1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure CmbBxEsquemasSelect(Sender: TObject);
    procedure ChkLstBx1Click(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure TrVwConsultaDDClick(Sender: TObject);
    procedure EdtTituloConsultaDDChange(Sender: TObject);
    procedure SpdBtnNuevoItemFavClick(Sender: TObject);
    procedure SpdBtnNuevoSubItemFavClick(Sender: TObject);
    procedure SpdBtnEliminarFavClick(Sender: TObject);
    procedure ActAbrirProgramaAccept(Sender: TObject);
    procedure SpdBtnPrograma1Click(Sender: TObject);
    procedure ChkBxConectarAutomaticamenteClick(Sender: TObject);
    procedure ChkBxConectarAutomaticamenteSesionClick(Sender: TObject);
    procedure LstVwTitulosPlantillasSelectItem(Sender: TObject;
      Item: TListItem; Selected: Boolean);
    procedure SynEditCodigoPlantillasChange(Sender: TObject);
    procedure SpdBtnEditarPlantillaClick(Sender: TObject);
    procedure SpdBtnAniadirPlantillaClick(Sender: TObject);
    procedure SpdBtnEliminarPlantillaClick(Sender: TObject);
    procedure BitBtnOkClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure SynEditKeyPress(Sender: TObject; var Key: Char);
    procedure SpdBtnAplicarFavClick(Sender: TObject);
    procedure TrVwConsultaDDGetImageIndex(Sender: TObject;
      Node: TTreeNode);
    procedure TrVwConsultaDDGetSelectedIndex(Sender: TObject;
      Node: TTreeNode);
    procedure TrVwConsultaDDCompare(Sender: TObject; Node1,
      Node2: TTreeNode; Data: Integer; var Compare: Integer);
    procedure SpdBtnExpandirFavClick(Sender: TObject);
    procedure SpdBtnContraerFavClick(Sender: TObject);
    procedure TrVwConsultaDDDragDrop(Sender, Source: TObject; X,
      Y: Integer);
    procedure Pegar1Click(Sender: TObject);
    procedure SpdBtnDocumentacionClick(Sender: TObject);
    procedure SpdBtnCambiarFavClick(Sender: TObject);
    procedure PageControlChange(Sender: TObject);
    procedure SpdBtnNuevoDirFavClick(Sender: TObject);
    procedure SpdBtnNuevoSubDirFavClick(Sender: TObject);
    procedure TrVwConsultaDDKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure RdGrpFormaConexionClick(Sender: TObject);
    procedure ChkBxGuardarIniClick(Sender: TObject);
    procedure PpMnuSynEditDefectoPopup(Sender: TObject);
    procedure SynEditStatusChange(Sender: TObject;
      Changes: TSynStatusChanges);
    procedure SynEditChange(Sender: TObject);
    procedure SpdBtnLimpiarClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }

    // Para editar el ttulo de un elemento del men de favoritos (dir o fich)
    Titulo: String;
    
    // Busca el rango que ocupa un item de autocompletado
//    procedure BuscarRango(Cabecera: String; var IComienzo, IFin: Integer);
    procedure BuscarRango(Item: TListItem; var IComienzo, IFin: Integer);

    procedure GuardarConfiguracionEditor;
    procedure CargarConfiguracionEditor;
    procedure AplicarConfiguracionEditor;

    procedure GuardarConfigAtributoSintaxis(SufijoShape: String; Indice: Integer);
    procedure CargarConfigAtributoSintaxis(SufijoShape: String; Indice: Integer);
    procedure ActualizarConfigAtributoSintaxis(Atributo: TSynHighlighterAttributes; SufijoShape: String; Indice: Integer);
    procedure AplicarConfigAtributoSintaxis(Atributo: TSynHighlighterAttributes; SufijoShape: String; Indice: Integer);
    procedure GuardarConfiguracionSintaxis;
    procedure CargarConfiguracionSintaxis;
    procedure ActualizarConfiguracionSintaxis;
    procedure AplicarConfiguracionSintaxis;

    procedure GuardarConfiguracionPrevisualizacionImpresion;
    procedure CargarConfiguracionPrevisualizacionImpresion;
    procedure AplicarConfiguracionPrevisualizacionImpresion;

    procedure GuardarConfiguracionOracle;
    procedure CargarConfiguracionOracle;
    procedure AplicarConfiguracionOracle;

    procedure GuardarConfiguracionProgramasFavoritos;
    procedure CargarConfiguracionProgramasFavoritos;
    procedure AplicarConfiguracionProgramasFavoritos;

    function ObtenerPathTreeView: String;
    procedure CargarLineasConsulta(Path: String; SE: TSynEdit);
    procedure ClickFavoritos(Sender: TObject);    
    procedure CargarFavoritos(Dir: string; MIPadre: TMenuItem; TNPadre: TTreeNode);
    procedure CargarConfiguracionMenuFavoritos;

    procedure GuardarConfiguracionPlantillas;
    procedure CargarConfiguracionPlantillas;
  end;

var
  FrmConfiguracion: TFrmConfiguracion;

implementation

{$R *.dfm}

uses UEditor, UPrincipal, UGlobal, UPreview, SynHighlighterSQL,
     ShellApi, Oracle, SynEditAutoComplete, UCabecerasPlantillas, UDMGlobal;

procedure TFrmConfiguracion.GuardarConfiguracionEditor;
var
  Ini : TIniFile;
begin
  try
    Ini := TIniFile.Create(ExtractFilePath(ParamStr(0)) + '\' + FichConfig);
// ELEMENTOS VISUALES
    Ini.WriteBool   ('CONF.EDITOR', 'MostrarNumLineas?', ChkBxNumLineas.Checked);
    Ini.WriteInteger('CONF.EDITOR', 'NumDigitos', SpnEdtDigitos.Value);
    Ini.WriteBool   ('CONF.EDITOR', 'MostrarMargen?', ChkBxMargen.Checked);
    Ini.WriteInteger('CONF.EDITOR', 'Margen', SpnEdtMargen.Value);
    Ini.WriteBool   ('CONF.EDITOR', 'MostrarGutter?', ChkBxGutter.Checked);
    Ini.WriteInteger('CONF.EDITOR', 'Gutter', SpnEdtGutter.Value);
// ELEMENTOS NO VISUALES
    Ini.WriteBool   ('CONF.EDITOR', 'PermitirHome?', ChkBxHome.Checked);
    Ini.WriteBool   ('CONF.EDITOR', 'PermitirTab?', ChkBxTab.Checked);
    Ini.WriteInteger('CONF.EDITOR', 'Tab', SpnEdtTab.Value);
    Ini.WriteInteger('CONF.EDITOR', 'Undo', SpnEdtUndo.Value);
    Ini.WriteInteger('CONF.EDITOR', 'Buffer', SpnEdtBuffer.Value);    
  finally
    Ini.Free;
  end;
end;

procedure TFrmConfiguracion.CargarConfiguracionEditor;
var
  Ini : TIniFile;
begin
  try
    Ini := TIniFile.Create(ExtractFilePath(ParamStr(0)) + '\' + FichConfig);
// ELEMENTOS VISUALES
    ChkBxNumLineas.Checked  := Ini.ReadBool   ('CONF.EDITOR', 'MostrarNumLineas?', true);
    SpnEdtDigitos.Value     := Ini.ReadInteger('CONF.EDITOR', 'NumDigitos', 5);
    ChkBxMargen.Checked     := Ini.ReadBool   ('CONF.EDITOR', 'MostrarMargen?', true);
    SpnEdtMargen.Value      := Ini.ReadInteger('CONF.EDITOR', 'Margen', 80);
    ChkBxGutter.Checked     := Ini.ReadBool   ('CONF.EDITOR', 'MostrarGutter?', true);
    SpnEdtGutter.Value      := Ini.ReadInteger('CONF.EDITOR', 'Gutter', 30);
// ELEMENTOS NO VISUALES
    ChkBxHome.Checked       := Ini.ReadBool   ('CONF.EDITOR', 'PermitirHome?', true);
    ChkBxTab.Checked        := Ini.ReadBool   ('CONF.EDITOR', 'PermitirTab?', false);
    SpnEdtTab.Value         := Ini.ReadInteger('CONF.EDITOR', 'Tab', 2);
    SpnEdtUndo.Value        := Ini.ReadInteger('CONF.EDITOR', 'Undo', 1024);
    SpnEdtBuffer.Value      := Ini.ReadInteger('CONF.EDITOR', 'Buffer', 1024);    
  finally
    Ini.Free;
  end;
end;

procedure TFrmConfiguracion.AplicarConfiguracionEditor;
begin
  if FrmPrincipal.MDIChildCount = 0 then
    Exit;
    
  with FrmPrincipal.ActiveMDIChild as TFrmEditor do
  begin
    with SynEdit do
    begin
      Gutter.ShowLineNumbers  := ChkBxNumLineas.Checked;
      Gutter.LeadingZeros     := true;
      Gutter.DigitCount       := SpnEdtDigitos.Value;
      // SpnEdtMargen.Cheked
      RightEdge               := SpnEdtMargen.Value;
      Gutter.Visible          := ChkBxGutter.Checked;
      Gutter.LeftOffset       := SpnEdtGutter.Value;
      if ChkBxHome.Checked then
        Options               := Options + [eoEnhanceHomeKey]
      else
        Options               := Options - [eoEnhanceHomeKey];

      if ChkBxTab.Checked then
        Options               := Options + [eoSmartTabs]
      else
        Options               := Options - [eoSmartTabs];
      TabWidth                := SpnEdtTab.Value;
      MaxUndo                 := SpnEdtUndo.Value;
    end;
  end;
end;

procedure TFrmConfiguracion.GuardarConfigAtributoSintaxis(SufijoShape: String; Indice: Integer);
var
  Ini : TIniFile;
  Shape : TComponent;
  Estilos: TFontStyles;
begin
  with FrmConfiguracion do
  begin
    Ini := TIniFile.Create(ExtractFilePath(ParamStr(0)) + '\' + FichConfig);
    try
      Shape := FindComponent('ShpBg' + SufijoShape);
      if Assigned(Shape) then
        Ini.WriteInteger('CONF.SINTAXIS', SufijoShape + 'BG', TShape(Shape).Brush.Color);

      Shape := FindComponent('ShpFg' + SufijoShape);
      if Assigned(Shape) then
        Ini.WriteInteger('CONF.SINTAXIS', SufijoShape + 'FG', TShape(Shape).Brush.Color);

      with TSynHighlighterAttributes.Create('inutil') do
        try // Esto es para poder usar el mtodo de traduccin, podra haberlo
            // copiado directamente, pero, as es mejor, porque si cambia la
            // librera, no hay que modificar el programa...
          Style := [];
          if Indice < 8 then
          begin
            if ChkLstBx1.Checked[Indice] then
              Style := Style + [fsBold];
            if ChkLstBx1.Checked[Indice+8] then
              Style := Style + [fsItalic];
            if ChkLstBx1.Checked[Indice+16] then
              Style := Style + [fsUnderline];
          end
          else begin
            if ChkLstBx2.Checked[Indice-8] then
              Style := Style + [fsBold];
            if ChkLstBx2.Checked[Indice-8+7] then
              Style := Style + [fsItalic];
            if ChkLstBx2.Checked[Indice-8+14] then
              Style := Style + [fsUnderline];
          end;
          Ini.WriteInteger('CONF.SINTAXIS', SufijoShape + 'Estilo', IntegerStyle);
        finally
          Free;
        end;
    finally
      Ini.Free;
    end;
  end;
end;


procedure TFrmConfiguracion.GuardarConfiguracionSintaxis;
var
  Ini : TIniFile;
begin
  try
    Ini := TIniFile.Create(ExtractFilePath(ParamStr(0)) + '\' + FichConfig);
    Ini.WriteBool('CONF.SINTAXIS', 'PermitirRealzadoSintaxis?', ChkBxRealzarSintaxis.Checked);
    Ini.WriteBool('CONF.SINTAXIS', 'UsarEsquemasPredefinidos?', ChkBxEsquemasPredefinidos.Checked);
    GuardarConfigAtributoSintaxis('Comentarios', 0);
    GuardarConfigAtributoSintaxis('Tipos', 1);
    GuardarConfigAtributoSintaxis('Paquetes', 2);
    GuardarConfigAtributoSintaxis('Excepciones', 3);
    GuardarConfigAtributoSintaxis('Funciones', 4);
    GuardarConfigAtributoSintaxis('Identificadores', 5);
    GuardarConfigAtributoSintaxis('Key', 6);
    GuardarConfigAtributoSintaxis('Numeros', 7);
    GuardarConfigAtributoSintaxis('PLSQL', 8);
    GuardarConfigAtributoSintaxis('Espacios', 9);
    GuardarConfigAtributoSintaxis('SQLPlus', 10);
    GuardarConfigAtributoSintaxis('Strings', 11);
    GuardarConfigAtributoSintaxis('Simbolos', 12);
    GuardarConfigAtributoSintaxis('Tablas', 13);
    GuardarConfigAtributoSintaxis('Variables', 14);
  finally
    Ini.Free;
  end;
end;

procedure TFrmConfiguracion.CargarConfigAtributoSintaxis(SufijoShape: String; Indice: Integer);
var
  Ini : TIniFile;
  Shape : TComponent;
  Estilos: TFontStyles;
begin
  with FrmConfiguracion do
  begin
    Ini := TIniFile.Create(ExtractFilePath(ParamStr(0)) + '\' + FichConfig);
    try
      Shape := FindComponent('ShpBg' + SufijoShape);
      if Assigned(Shape) then
        TShape(Shape).Brush.Color   := Ini.ReadInteger('CONF.SINTAXIS', SufijoShape + 'BG', $FFFFFF);

      Shape := FindComponent('ShpFg' + SufijoShape);
      if Assigned(Shape) then
        TShape(Shape).Brush.Color   := Ini.ReadInteger('CONF.SINTAXIS', SufijoShape + 'FG', 0);

      with TSynHighlighterAttributes.Create('inutil') do
      try // Esto es para poder usar el mtodo de traduccin, podra haberlo
          // copiado directamente, pero, as es mejor, porque si cambia la
          // librera, no hay que modificar el programa...
        IntegerStyle := Ini.ReadInteger('CONF.SINTAXIS', SufijoShape + 'Estilo', 0);
        if Indice < 8 then
        begin
          ChkLstBx1.Checked[Indice]     := fsBold       in Style;
          ChkLstBx1.Checked[Indice+8]   := fsItalic     in Style;
          ChkLstBx1.Checked[Indice+16]  := fsUnderline  in Style;
        end
        else begin
          ChkLstBx2.Checked[Indice-8]   := fsBold       in Style;
          ChkLstBx2.Checked[Indice-8+7] := fsItalic     in Style;
          ChkLstBx2.Checked[Indice-8+14]:= fsUnderline  in Style;
        end;
      finally
        Free;
      end;
    finally
      Ini.Free
    end;
  end;
end;

procedure TFrmConfiguracion.CargarConfiguracionSintaxis;
var
  Ini : TIniFile;
begin
  try
    Ini := TIniFile.Create(ExtractFilePath(ParamStr(0)) + '\' + FichConfig);
    ChkBxRealzarSintaxis.Checked      := Ini.ReadBool('CONF.SINTAXIS', 'PermitirRealzadoSintaxis?', true);
    ChkBxEsquemasPredefinidos.Checked := Ini.ReadBool('CONF.SINTAXIS', 'UsarEsquemasPredefinidos?', true);
    CargarConfigAtributoSintaxis('Comentarios', 0);
    CargarConfigAtributoSintaxis('Tipos', 1);
    CargarConfigAtributoSintaxis('Paquetes', 2);
    CargarConfigAtributoSintaxis('Excepciones', 3);
    CargarConfigAtributoSintaxis('Funciones', 4);
    CargarConfigAtributoSintaxis('Identificadores', 5);
    CargarConfigAtributoSintaxis('Key', 6);
    CargarConfigAtributoSintaxis('Numeros', 7);
    CargarConfigAtributoSintaxis('PLSQL', 8);
    CargarConfigAtributoSintaxis('Espacios', 9);
    CargarConfigAtributoSintaxis('SQLPlus', 10);
    CargarConfigAtributoSintaxis('Strings', 11);
    CargarConfigAtributoSintaxis('Simbolos', 12);
    CargarConfigAtributoSintaxis('Tablas', 13);
    CargarConfigAtributoSintaxis('Variables', 14);
  finally
    Ini.Free;
  end;
end;


procedure TFrmConfiguracion.ActualizarConfigAtributoSintaxis(Atributo: TSynHighlighterAttributes; SufijoShape: String; Indice: Integer);
var
  Shape : TComponent;
  Estilos: TFontStyles;
begin
{  with FrmConfiguracion do
  begin
    Shape := FindComponent('ShpBg' + SufijoShape);
    if Assigned(Shape) then
      TShape(Shape).Brush.Color := Atributo.Background;

    Shape := FindComponent('ShpFg' + SufijoShape);
    if Assigned(Shape) then
      TShape(Shape).Brush.Color := Atributo.Foreground;

    if Indice < 8 then
    begin
      ChkLstBx1.Checked[Indice]       := fsBold       in Atributo.Style;
      ChkLstBx1.Checked[Indice + 8]   := fsItalic     in Atributo.Style;
      ChkLstBx1.Checked[Indice + 16]  := fsUnderline  in Atributo.Style;
    end
    else begin
      ChkLstBx1.Checked[Indice - 8]       := fsBold       in Atributo.Style;
      ChkLstBx1.Checked[Indice - 8 + 7]   := fsItalic     in Atributo.Style;
      ChkLstBx1.Checked[Indice - 8 + 14]  := fsUnderline  in Atributo.Style;
    end;
  end;}
end;


procedure TFrmConfiguracion.ActualizarConfiguracionSintaxis;
var
  i : Integer;
begin
  if FrmPrincipal.MDIChildCount = 0 then
    Exit;

  with DMGlobal.SynSQLSyn do
  begin
    ShpBgComentarios.Brush.Color  := CommentAttri.Background;
    ShpFgComentarios.Brush.Color  := CommentAttri.Foreground;
    ChkLstBx1.Checked[ 0]         := fsBold       in CommentAttri.Style;
    ChkLstBx1.Checked[ 8]         := fsItalic     in CommentAttri.Style;
    ChkLstBx1.Checked[16]         := fsUnderline  in CommentAttri.Style;

    ShpBgTipos.Brush.Color        := DataTypeAttri.Background;
    ShpFgTipos.Brush.Color        := DataTypeAttri.Foreground;
    ChkLstBx1.Checked[ 1]         := fsBold       in DataTypeAttri.Style;
    ChkLstBx1.Checked[ 9]         := fsItalic     in DataTypeAttri.Style;
    ChkLstBx1.Checked[17]         := fsUnderline  in DataTypeAttri.Style;

    ShpBgPaquetes.Brush.Color     := DefaultPackageAttri.Background;
    ShpFgPaquetes.Brush.Color     := DefaultPackageAttri.Foreground;
    ChkLstBx1.Checked[ 2]         := fsBold       in DefaultPackageAttri.Style;
    ChkLstBx1.Checked[10]         := fsItalic     in DefaultPackageAttri.Style;
    ChkLstBx1.Checked[18]         := fsUnderline  in DefaultPackageAttri.Style;

    ShpBgExcepciones.Brush.Color  := ExceptionAttri.Background;
    ShpFgExcepciones.Brush.Color  := ExceptionAttri.Foreground;
    ChkLstBx1.Checked[ 3]         := fsBold       in ExceptionAttri.Style;
    ChkLstBx1.Checked[11]         := fsItalic     in ExceptionAttri.Style;
    ChkLstBx1.Checked[19]         := fsUnderline  in ExceptionAttri.Style;

    ShpBgFunciones.Brush.Color    := FunctionAttri.Background;
    ShpFgFunciones.Brush.Color    := FunctionAttri.Foreground;
    ChkLstBx1.Checked[ 4]         := fsBold       in FunctionAttri.Style;
    ChkLstBx1.Checked[12]         := fsItalic     in FunctionAttri.Style;
    ChkLstBx1.Checked[20]         := fsUnderline  in FunctionAttri.Style;

    ShpBgIdentificadores.Brush.Color := IdentifierAttri.Background;
    ShpFgIdentificadores.Brush.Color := IdentifierAttri.Foreground;
    ChkLstBx1.Checked[ 5]         := fsBold       in IdentifierAttri.Style;
    ChkLstBx1.Checked[13]         := fsItalic     in IdentifierAttri.Style;
    ChkLstBx1.Checked[21]         := fsUnderline  in IdentifierAttri.Style;

    ShpBgKey.Brush.Color          := KeyAttri.Background;
    ShpFgKey.Brush.Color          := KeyAttri.Foreground;
    ChkLstBx1.Checked[ 6]         := fsBold       in KeyAttri.Style;
    ChkLstBx1.Checked[14]         := fsItalic     in KeyAttri.Style;
    ChkLstBx1.Checked[22]         := fsUnderline  in KeyAttri.Style;

    ShpBgNumeros.Brush.Color      := NumberAttri.Background;
    ShpFgNumeros.Brush.Color      := NumberAttri.Foreground;
    ChkLstBx1.Checked[ 7]         := fsBold       in NumberAttri.Style;
    ChkLstBx1.Checked[15]         := fsItalic     in NumberAttri.Style;
    ChkLstBx1.Checked[23]         := fsUnderline  in NumberAttri.Style;

    ShpBgPLSQL.Brush.Color        := PLSQLAttri.Background;
    ShpFgPLSQL.Brush.Color        := PLSQLAttri.Foreground;
    ChkLstBx2.Checked[ 0]         := fsBold       in PLSQLAttri.Style;
    ChkLstBx2.Checked[ 7]         := fsItalic     in PLSQLAttri.Style;
    ChkLstBx2.Checked[14]         := fsUnderline  in PLSQLAttri.Style;

    ShpBgEspacios.Brush.Color     := SpaceAttri.Background;
    ShpFgEspacios.Brush.Color     := SpaceAttri.Foreground;
    ChkLstBx2.Checked[ 1]         := fsBold       in SpaceAttri.Style;
    ChkLstBx2.Checked[ 8]         := fsItalic     in SpaceAttri.Style;
    ChkLstBx2.Checked[15]         := fsUnderline  in SpaceAttri.Style;

    ShpBgSQLPlus.Brush.Color      := SQLPlusAttri.Background;
    ShpFgSQLPlus.Brush.Color      := SQLPlusAttri.Foreground;
    ChkLstBx2.Checked[ 2]         := fsBold       in SQLPlusAttri.Style;
    ChkLstBx2.Checked[ 9]         := fsItalic     in SQLPlusAttri.Style;
    ChkLstBx2.Checked[16]         := fsUnderline  in SQLPlusAttri.Style;

    ShpBgStrings.Brush.Color      := StringAttri.Background;
    ShpFgStrings.Brush.Color      := StringAttri.Foreground;
    ChkLstBx2.Checked[ 3]         := fsBold       in StringAttri.Style;
    ChkLstBx2.Checked[10]         := fsItalic     in StringAttri.Style;
    ChkLstBx2.Checked[17]         := fsUnderline  in StringAttri.Style;

    ShpBgSimbolos.Brush.Color     := SymbolAttri.Background;
    ShpFgSimbolos.Brush.Color     := SymbolAttri.Foreground;
    ChkLstBx2.Checked[ 4]         := fsBold       in SymbolAttri.Style;
    ChkLstBx2.Checked[11]         := fsItalic     in SymbolAttri.Style;
    ChkLstBx2.Checked[18]         := fsUnderline  in SymbolAttri.Style;

    ShpBgTablas.Brush.Color       := TableNameAttri.Background;
    ShpFgTablas.Brush.Color       := TableNameAttri.Foreground;
    ChkLstBx2.Checked[ 5]         := fsBold       in TableNameAttri.Style;
    ChkLstBx2.Checked[12]         := fsItalic     in TableNameAttri.Style;
    ChkLstBx2.Checked[19]         := fsUnderline  in TableNameAttri.Style;

    ShpBgVariables.Brush.Color    := VariableAttri.Background;
    ShpFgVariables.Brush.Color    := VariableAttri.Foreground;
    ChkLstBx2.Checked[ 6]         := fsBold       in VariableAttri.Style;
    ChkLstBx2.Checked[13]         := fsItalic     in VariableAttri.Style;
    ChkLstBx2.Checked[20]         := fsUnderline  in VariableAttri.Style;
    for i := 0 to PageControl.ActivePage.ComponentCount-1 do
      if PageControl.ActivePage.Components[i] is TShape then
        TShape(PageControl.ActivePage.Components[i]).Enabled :=
                                         (ChkBxRealzarSintaxis.Checked) and
                                         (not ChkBxEsquemasPredefinidos.Checked);
  end;
end;

procedure TFrmConfiguracion.AplicarConfigAtributoSintaxis(Atributo: TSynHighlighterAttributes; SufijoShape: String; Indice: Integer);
var
  Shape : TComponent;
  Estilos: TFontStyles;
begin
  with FrmConfiguracion do
  begin
    Shape := FindComponent('ShpBg' + SufijoShape);
    if Assigned(Shape) then
      Atributo.Background := TShape(Shape).Brush.Color;

    Shape := FindComponent('ShpFg' + SufijoShape);
    if Assigned(Shape) then
      Atributo.Foreground := TShape(Shape).Brush.Color;

    if Indice < 8 then
    begin
      if ChkLstBx1.Checked[Indice] then
        Atributo.Style := Atributo.Style + [fsBold]
      else
        Atributo.Style := Atributo.Style - [fsBold];

      if ChkLstBx1.Checked[Indice + 8] then
        Atributo.Style := Atributo.Style + [fsItalic]
      else
        Atributo.Style := Atributo.Style - [fsItalic];

      if ChkLstBx1.Checked[Indice + 16] then
        Atributo.Style := Atributo.Style + [fsUnderline]
      else
        Atributo.Style := Atributo.Style - [fsUnderline];
    end
    else begin
      if ChkLstBx2.Checked[Indice - 8] then
        Atributo.Style := Atributo.Style + [fsBold]
      else
        Atributo.Style := Atributo.Style - [fsBold];

      if ChkLstBx2.Checked[Indice - 8 + 7] then
        Atributo.Style := Atributo.Style + [fsItalic]
      else
        Atributo.Style := Atributo.Style - [fsItalic];

      if ChkLstBx1.Checked[Indice -8 + 14] then
        Atributo.Style := Atributo.Style + [fsUnderline]
      else
        Atributo.Style := Atributo.Style - [fsUnderline];
    end;
  end;
end;

procedure TFrmConfiguracion.AplicarConfiguracionSintaxis;
begin
{  if FrmPrincipal.MDIChildCount = 0 then
    Exit;}

  with DMGlobal.SynSQLSyn do
  begin
    AplicarConfigAtributoSintaxis(CommentAttri, 'Comentarios', 0);
    AplicarConfigAtributoSintaxis(DataTypeAttri, 'Comentarios', 1);
    AplicarConfigAtributoSintaxis(DefaultPackageAttri, 'Paquetes', 2);
    AplicarConfigAtributoSintaxis(ExceptionAttri, 'Excepciones', 3);
    AplicarConfigAtributoSintaxis(FunctionAttri, 'Funciones', 4);
    AplicarConfigAtributoSintaxis(IdentifierAttri, 'Identificadores', 5);
    AplicarConfigAtributoSintaxis(KeyAttri, 'Key', 6);
    AplicarConfigAtributoSintaxis(NumberAttri, 'Numeros', 7);
    AplicarConfigAtributoSintaxis(PLSQLAttri, 'PLSQL', 8);
    AplicarConfigAtributoSintaxis(SpaceAttri, 'Espacios', 9);
    AplicarConfigAtributoSintaxis(SQLPlusAttri, 'SQLPlus' , 10);
    AplicarConfigAtributoSintaxis(StringAttri, 'Strings', 11);
    AplicarConfigAtributoSintaxis(SymbolAttri, 'Simbolos', 12);
    AplicarConfigAtributoSintaxis(TableNameAttri, 'Tablas', 13);
    AplicarConfigAtributoSintaxis(VariableAttri, 'Variables', 14);
  end;
end;

procedure TFrmConfiguracion.GuardarConfiguracionPrevisualizacionImpresion;
var
  Ini : TIniFile;
begin
  try
    Ini := TIniFile.Create(ExtractFilePath(ParamStr(0)) + '\' + FichConfig);
    Ini.WriteBool   ('CONF.PREV&IMP', 'PermitirRealzadoSintaxis?', ChkBxImpresionBlancoNegro.Checked);
    Ini.WriteBool   ('CONF.PREV&IMP', 'RealzarSintaxisPrevisualizacionImpresion?', ChkBxRealzarSintaxisPrevisualizacionImpresion.Checked);
    Ini.WriteBool   ('CONF.PREV&IMP', 'EnumerarLineas?', ChkBxEnumerarLineas.Checked);
    Ini.WriteBool   ('CONF.PREV&IMP', 'MostrarPiePagina?', ChkBxMostrarPiePagina.Checked);
    Ini.WriteString ('CONF.PREV&IMP', 'Usuario',          EdtUsuario.Text);
    Ini.WriteInteger('CONF.PREV&IMP', 'MargenIzquierdo',  SpnEdtIzquierdo.Value);
    Ini.WriteInteger('CONF.PREV&IMP', 'MargenSuperior',   SpnEdtSuperior.Value);
    Ini.WriteInteger('CONF.PREV&IMP', 'MargenDerecho',    SpnEdtDerecho.Value);
    Ini.WriteInteger('CONF.PREV&IMP', 'MargenInferior',   SpnEdtInferior.Value);
    Ini.WriteInteger('CONF.PREV&IMP', 'MargenPiePagina',  SpnEdtPiePagina.Value);
  finally
    Ini.Free;
  end;
end;

procedure TFrmConfiguracion.CargarConfiguracionPrevisualizacionImpresion;
var
  Ini : TIniFile;
begin
  try
    Ini := TIniFile.Create(ExtractFilePath(ParamStr(0)) + '\' + FichConfig);
    ChkBxImpresionBlancoNegro.Checked       := Ini.ReadBool('CONF.PREV&IMP', 'PermitirRealzadoSintaxis?', false);
    ChkBxRealzarSintaxisPrevisualizacionImpresion.Checked := Ini.ReadBool('CONF.PREV&IMP', 'RealzarSintaxisPrevisualizacionImpresion?', true);
    ChkBxEnumerarLineas.Checked             := Ini.ReadBool('CONF.PREV&IMP', 'EnumerarLineas?', true);
    ChkBxMostrarPiePagina.Checked           := Ini.ReadBool('CONF.PREV&IMP', 'MostrarPiePagina?', true);
    EdtUsuario.Text                         := Ini.ReadString ('CONF.PREV&IMP', 'Usuario', '');
    SpnEdtIzquierdo.Value                   := Ini.ReadInteger('CONF.PREV&IMP', 'MargenIzquierdo',  15);
    SpnEdtSuperior.Value                    := Ini.ReadInteger('CONF.PREV&IMP', 'MargenSuperior',   15);
    SpnEdtDerecho.Value                     := Ini.ReadInteger('CONF.PREV&IMP', 'MargenDerecho',    15);
    SpnEdtInferior.Value                    := Ini.ReadInteger('CONF.PREV&IMP', 'MargenInferior',   15);
    SpnEdtPiePagina.Value                   := Ini.ReadInteger('CONF.PREV&IMP', 'MargenPiePagina',   15);
  finally
    Ini.Free;
  end;
end;

procedure TFrmConfiguracion.AplicarConfiguracionPrevisualizacionImpresion;
begin
  with FrmPreview do
  begin
    SynEditPrint.Highlight      := ChkBxRealzarSintaxisPrevisualizacionImpresion.Checked;
    if ChkBxImpresionBlancoNegro.Checked then
    begin
      SynEditPrint.Colors := false //.Highlighter := FrmPreview.SynSQLSyn;
    end
    else
    begin
      SynEditPrint.Colors := true //.Highlighter := FrmPrincipal.SynSQLSyn;
    end;
    SynEditPrint.LineNumbers    := ChkBxEnumerarLineas.Checked;
    SynEditPrint.LineNumbersInMargin := false;
    // ChkBxMostrarPiePagina.Checked;
    // EdtUsuario.Text;
    // Estos dos valores se configuran dinamicamente al ejecutar la
    // accion correspondiente.
    SynEditPrint.Margins.Left   := SpnEdtIzquierdo.Value;
    SynEditPrint.Margins.Top    := SpnEdtSuperior.Value;
    SynEditPrint.Margins.Right  := SpnEdtDerecho.Value;
    SynEditPrint.Margins.Bottom := SpnEdtInferior.Value;
    SynEditPrint.Margins.Footer := SpnEdtPiePagina.Value;
  end;
end;

procedure TFrmConfiguracion.GuardarConfiguracionOracle;
var
  Ini : TIniFile;
begin
  try
    Ini := TIniFile.Create(ExtractFilePath(ParamStr(0)) + '\' + FichConfig);
    Ini.WriteString ('CONF.ORACLE', 'Documentacion', LblDocumentacion.Caption);
    Ini.WriteInteger('CONF.ORACLE', 'TipoConexion',  RdGrpFormaConexion.ItemIndex);
    Ini.WriteString ('CONF.ORACLE', 'Login',         EdtLogin.Text);
    Ini.WriteBool   ('CONF.ORACLE', 'GuardarPassIni?', ChkBxGuardarIni.Checked);
    if (ChkBxGuardarIni.Checked) and (RdGrpFormaConexion.ItemIndex = 2) then
      Ini.WriteString ('CONF.ORACLE', 'Password', EdtPassword.Text)
    else if RdGrpFormaConexion.ItemIndex = 2 then
      Ini.WriteString ('CONF.ORACLE', 'Password', '');
    Ini.WriteBool   ('CONF.ORACLE', 'ConectarAutomaticamenteSesion?', ChkBxConectarAutomaticamenteSesion.Checked);
    Ini.WriteBool   ('CONF.ORACLE', 'ConectarAutomaticamente?', ChkBxConectarAutomaticamente.Checked);
  finally
    Ini.Free;
  end;
end;

procedure TFrmConfiguracion.CargarConfiguracionOracle;
var
  Ini : TIniFile;
begin
  try
    Ini := TIniFile.Create(ExtractFilePath(ParamStr(0)) + '\' + FichConfig);
    LblDocumentacion.Caption      := Ini.ReadString('CONF.ORACLE', 'Documentacion', 'Documentacin');
    RdGrpFormaConexion.ItemIndex  := Ini.ReadInteger('CONF.ORACLE', 'TipoConexion', 0);
    ChkBxGuardarIni.OnClick := nil;
    ChkBxGuardarIni.Checked       := Ini.ReadBool   ('CONF.ORACLE', 'GuardarPassIni?', false);
    ChkBxGuardarIni.OnClick := ChkBxGuardarIniClick;
    EdtLogin.Text                 := Ini.ReadString('CONF.ORACLE', 'Login', 'System');
{    if Ini.ReadString('CONF.ORACLE', 'Password', '') = '' then
      EdtPassword.Text            := ''
    else}
      EdtPassword.Text            := Ini.ReadString('CONF.ORACLE', 'Password', '');
    ChkBxConectarAutomaticamenteSesion.Checked := Ini.ReadBool('CONF.ORACLE', 'ConectarAutomaticamenteSesion?', false);
    ChkBxConectarAutomaticamente.Checked := Ini.ReadBool  ('CONF.ORACLE', 'ConectarAutomaticamente?', false);
  finally
    Ini.Free;
  end;
end;

procedure TFrmConfiguracion.AplicarConfiguracionOracle;
begin
  if FrmPrincipal.MDIChildCount = 0 then
    Exit;
    
  with (FrmPrincipal.ActiveMDIChild as TFrmEditor).OracleSession do
    if not Connected then
    begin
      LogonUsername := (FrmPrincipal.MDIChildren[0] as TFrmEditor).OracleSession.LogonUsername;
      LogonPassword := (FrmPrincipal.MDIChildren[0] as TFrmEditor).OracleSession.LogonPassword;
// TODO: QUEDO      
{      ShowMessage((FrmPrincipal.MDIChildren[0] as TFrmEditor).OracleSession.LogonUsername);
      ShowMessage((FrmPrincipal.MDIChildren[0] as TFrmEditor).OracleSession.LogonPassword);
      ShowMessage('Logon: ' + LogonUserName + 'Passwd: ' + LogonPassword);
      ShowMessage('MDIChildCount: ' + IntToStr(FrmPrincipal.MDIChildCount));
      if (FrmPrincipal.MDIChildren[0] as TFrmEditor).OracleSession.Connected then
        ShowMessage('conectado');}
      if (ChkBxConectarAutomaticamente.Checked) and
         (FrmPrincipal.ActiveMDIChild <> FrmPrincipal.MDIChildren[0]) then
        (FrmPrincipal.ActiveMDIChild as TFrmEditor).ActOracleConectarDesconectar.Execute;
    end;
end;

procedure TFrmConfiguracion.GuardarConfiguracionProgramasFavoritos;
var
  Ini : TIniFile;
  i   : Integer;
begin
  try
    Ini := TIniFile.Create(ExtractFilePath(ParamStr(0)) + '\' + FichConfig);
    for i := 1 to 5 do
      Ini.WriteString('CONF.PROGS', IntToStr(i),
        TLabel(FindComponent('LblPrograma' + IntToStr(i))).Caption +
        '|' + TEdit(FindComponent('EdtNombre' + IntToStr(i))).Text +
        '|' + TEdit(FindComponent('EdtArgs' + IntToStr(i))).Text
                     );
  finally
    Ini.Free;
  end;
end;

procedure TFrmConfiguracion.CargarConfiguracionProgramasFavoritos;
var
  Ini : TIniFile;
  i   : Integer;
  Str : String;
begin
  try
    Ini := TIniFile.Create(ExtractFilePath(ParamStr(0)) + '\' + FichConfig);
    for i := 1 to 5 do
    begin
      Str := Ini.ReadString('CONF.PROGS', IntToStr(i), '');
      if GetToken(Str, '|', 1) <> '' then
        TLabel(FindComponent('LblPrograma' + IntToStr(i))).Caption := GetToken(Str, '|', 1)
      else
        TLabel(FindComponent('LblPrograma' + IntToStr(i))).Caption := 'Programa no asignado';
//      if GetToken(Str, '|', 2) <> '' then
      TEdit(FindComponent('EdtNombre' + IntToStr(i))).Text := GetToken(Str, '|', 2);
{      else
        TEdit(FindComponent('EdtNombre' + IntToStr(i))).Text := ;}
      TEdit(FindComponent('EdtArgs' + IntToStr(i))).Text := GetToken(Str, '|', 3);
    end;
  finally
    Ini.Free;
  end;
end;

procedure TFrmConfiguracion.AplicarConfiguracionProgramasFavoritos;
var
  i : Integer;
begin
  for i := 1 to 5 do
    if Assigned(FindComponent('SpdBtnPrograma' + IntToStr(i))) and
       Assigned(FrmPrincipal.FindComponent('MIProgramaFavorito' + IntToStr(i))) and
       Assigned(FindComponent('LblPrograma' + IntToStr(i))) and
       Assigned(FindComponent('EdtNombre' + IntToStr(i))) and
       Assigned(FindComponent('EdtArgs' + IntToStr(i))) then
    begin
//      ShowMessage(TEdit(FindComponent('EdtNombre' + IntToStr(i))).Text);
      if TEdit(FindComponent('EdtNombre' + IntToStr(i))).Text <> '' then
        TMenuItem(FrmPrincipal.FindComponent('MIProgramaFavorito' + IntToStr(i))).Caption :=
          TEdit(FindComponent('EdtNombre' + IntToStr(i))).Text
      else
        TMenuItem(FrmPrincipal.FindComponent('MIProgramaFavorito' + IntToStr(i))).Caption :=
          '<- Programa favorito ' + IntToStr(i) + ' ->'
{      ExtractFileName(TLabel(FindComponent('LblPrograma' + IntToStr(i))).Caption) +
      ' ' + TEdit(FindComponent('EdtArgs' + IntToStr(i))).Text;}
//      ShowMessage(ExtractFileName(TLabel(FindComponent('LblPrograma' + IntToStr(i))).Caption))
    end;
end;


function ComponentToString(Component: TComponent): string;

var
  BinStream:TMemoryStream;
  StrStream: TStringStream;
  s: string;
begin
  BinStream := TMemoryStream.Create;
  try
    StrStream := TStringStream.Create(s);
    try
      BinStream.WriteComponent(Component);
      BinStream.Seek(0, soFromBeginning);
      ObjectBinaryToText(BinStream, StrStream);
      StrStream.Seek(0, soFromBeginning);
      Result:= StrStream.DataString;
    finally
      StrStream.Free;

    end;
  finally
    BinStream.Free
  end;
end;

procedure TFrmConfiguracion.ClickFavoritos(Sender: TObject);
var
  Ventana : TFrmEditor;
begin
  Ventana := TFrmEditor.Create(nil);
  CargarLineasConsulta(TMenuItem(Sender).Hint, Ventana.SynEdit);
end;

procedure CrearItemFavFich(AFileName: string; MIPadre: TMenuItem; var MIHijo: TMenuItem;
                           TNPadre: TTreeNode; var TNHijo: TTreeNode);
var
//  Item: TMenuItem;
  Cap: string;
  Url: string;
begin
  MIHijo := TMenuItem.Create(MIPadre);
  Cap := Copy(ExtractFileName(AFileName), 1, Length(ExtractFileName(AFileName)) - Length(ExtractFileExt(ExtractFileName(AFileName))));
{  if Length(Cap) > 20 then
    Cap := Copy(Cap, 1, 20) + '..';}
  MIHijo.ImageIndex := 91;// 92;
  MIHijo.Caption := Cap;
  MIHijo.Hint := AFileName;//ReadUrl(AFileName);
  MIHijo.OnClick := FrmConfiguracion.ClickFavoritos;
  MIPadre.Add(MIHijo);

  TNHijo := FrmConfiguracion.TrVwConsultaDD.Items.Add(nil, ExtractFileName(AFileName));
  TNHijo.ImageIndex := 91;
  TNHijo.MoveTo(TNPadre, naAddChild);
end;

procedure CrearItemFavDir(AFileName: string; MIPadre: TMenuItem; var MIHijo: TMenuItem;
                          var TNPadre: TTreeNode; var TNHijo: TTreeNode);
begin
  MIHijo := TMenuItem.Create(MIPadre);
  MIHijo.Caption := ExtractFileName(AFileName);
  MIHijo.ImageIndex := 127;
  MIPadre.Insert(0, MIHijo);

  // Hasta que descubr que el hijo NO SE DEBE crear, casi me vuelvo loco!!!
  if TNPadre = nil then
    TNHijo := FrmConfiguracion.TrVwConsultaDD.Items.Add(nil, ExtractFileName(AFileName))
  else begin
    TNHijo := FrmConfiguracion.TrVwConsultaDD.Items.Add(nil, ExtractFileName(AFileName));
    TNHijo.MoveTo(TNPadre, naAddChild);
  end;
end;

procedure TFrmConfiguracion.CargarFavoritos(Dir: string; MIPadre: TMenuItem; TNPadre: TTreeNode);
var
  Search: TSearchRec;
  MIHijo: TMenuItem;
  TNHijo: TTreeNode;
begin
  if Dir[length(Dir)] <> '\' then
    Dir := Dir + '\';

  if FindFirst(Dir + '*.*', faArchive + faDirectory, Search) = 0 then
  begin
    repeat
      if ((Search.Attr and faDirectory) = faDirectory) and (Search.name[1] <> '.') then
      begin
        CrearItemFavDir(Dir + search.Name, MIPadre, MIHijo, TNPadre, TNHijo);
        CargarFavoritos(Dir + search.Name, MIHijo, TNHijo);
      end
      else if ((Search.name[1] <> '.') and (Search.name[1] <> '..')) then
        CrearItemFavFich(Dir + search.Name, MIPadre, MIHijo, TNPadre, TNHijo);
    until FindNext(search) <> 0;
    FindClose(search);
  end;
end;

procedure TFrmConfiguracion.CargarConfiguracionMenuFavoritos;
var
  i : Integer;
begin
  FrmPrincipal.MIFavoritos.Clear;
  TrVwConsultaDD.Items.Clear;
  CargarFavoritos(ExtractFilePath(ParamStr(0)) + 'Favoritos', FrmPrincipal.MIFavoritos, nil);//TrVwConsultaDD.Items.Add(nil, 'Raiz'));
//  TrVwConsultaDD.SortType := stText;
  for i := 0 to TrVwConsultaDD.Items.Count -1 do
    TrVwConsultaDD.Items[i].Collapse(true);
end;

procedure TFrmConfiguracion.GuardarConfiguracionPlantillas;
begin
{  if FrmPrincipal.MDIChildCount = 0 then
    Exit;}

  DMGlobal.SynAutoComplete.AutoCompleteList.SaveToFile(
    ExtractFilePath(ParamStr(0)) + 'Plantillas\' + FichDCI);
end;

procedure TFrmConfiguracion.CargarConfiguracionPlantillas;
var
  i : Integer;
  Editor  : TFrmEditor;
begin
  // TODO: Arreglar esto
{  if FrmPrincipal.MDIChildCount = 0 then
    Exit;

  Editor := TFrmEditor(FrmPrincipal.ActiveMDIChild);}
  FrmConfiguracion.LstVwTitulosPlantillas.Clear;
  DMGlobal.SynAutoComplete.Completions.Clear;  
  DMGlobal.SynAutoComplete.AutoCompleteList.LoadFromFile(
    ExtractFilePath(ParamStr(0)) + 'Plantillas\' + FichDCI);
  SynEditCodigoPlantillas.ClearAll;

  if PageControl.ActivePage = TbShtPlantillas then
  begin
//    ActiveControl := SynEditCodigoPlantillas; // Con esto limpiamos la seleccin
    LstVwTitulosPlantillas.Selected := nil;   // y con esto tambin
//    ActiveControl := LstVwTitulosPlantillas;
  end;

  for i := 0 to DMGlobal.SynAutoComplete.Completions.Count - 1 do
  begin
    with LstVwTitulosPlantillas do
    begin
      Items.Add;
      Items[i].Caption := DMGlobal.SynAutoComplete.Completions[i];
      Items[i].SubItems.Add(DMGlobal.SynAutoComplete.CompletionComments[i])
    end;

  {  ShowMessage('Cabecera: ' + fAutoComplete.AutoCompleteList[0] + #13 +
              'Nombre: ' + fAutoComplete.Completions[0] + #13 +
              'Comentarios: ' + fAutoComplete.CompletionComments[0] + #13 +
              'Macro: ' + fAutoComplete.CompletionValues[0])}
  end;
end;

procedure TFrmConfiguracion.ChkBxNumLineasClick(Sender: TObject);
begin
  LblDigitos.Enabled := ChkBxNumLineas.Checked;
  SpnEdtDigitos.Enabled := ChkBxNumLineas.Checked;
end;

procedure TFrmConfiguracion.ChkBxMargenClick(Sender: TObject);
begin
  LblMargen.Enabled := ChkBxMargen.Checked;
  SpnEdtMargen.Enabled := ChkBxMargen.Checked;
end;

procedure TFrmConfiguracion.ChkBxGutterClick(Sender: TObject);
begin
  if ChkBxGutter.Checked then
  begin
    LblGutter.Enabled       := true;
    SpnEdtGutter.Enabled    := true;
    ChkBxNumLineas.Enabled  := true;
    LblDigitos.Enabled      := true;
    SpnEdtDigitos.Enabled   := true;
  end
  else begin
    LblGutter.Enabled       := false;
    SpnEdtGutter.Enabled    := false;
    ChkBxNumLineas.Enabled  := false;
    LblDigitos.Enabled      := false;
    SpnEdtDigitos.Enabled   := false;
  end;
end;

procedure TFrmConfiguracion.ShpBgComentariosMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  ColorDialog.Color := TShape(Sender).Brush.Color;
  if ColorDialog.Execute then
  begin
    TShape(Sender).Brush.Color := ColorDialog.Color;
    AplicarConfiguracionSintaxis;
  end;
end;

procedure TFrmConfiguracion.ChkBxEsquemasPredefinidosClick(
  Sender: TObject);
begin
  ActualizarConfiguracionSintaxis;
end;

procedure TFrmConfiguracion.ChkBxRealzarSintaxisClick(Sender: TObject);
begin
  if FrmPrincipal.MDIChildCount = 0 then
    Exit;

  {(FrmPrincipal.ActiveMDIChild as TFrmEditor)}DMGlobal.SynSQLSyn.Enabled := ChkBxRealzarSintaxis.Checked;
  ActualizarConfiguracionSintaxis;
end;

procedure TFrmConfiguracion.Shape1MouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  ReleaseCapture;
  Perform(WM_SYSCOMMAND, $F012, 0);
end;

procedure TFrmConfiguracion.CmbBxEsquemasSelect(Sender: TObject);
begin
  with (DMGlobal{FrmPrincipal.ActiveMDIChild as TFrmEditor}).SynSQLSyn do
    case CmbBxEsquemas.ItemIndex of
      0 : SQLDialect := sqlIngres;
      1 : SQLDialect := sqlInterbase6;
      2 : SQLDialect := sqlMSSQL2K;
      3 : SQLDialect := sqlMSSQL7;
      4 : SQLDialect := sqlMySQL;
      5 : SQLDialect := sqlOracle;
      6 : SQLDialect := sqlStandard;
      7 : SQLDialect := sqlSybase;
    end;
  ActualizarConfiguracionSintaxis;
end;

procedure TFrmConfiguracion.ChkLstBx1Click(Sender: TObject);
begin
  AplicarConfiguracionSintaxis;
end;

procedure TFrmConfiguracion.FormActivate(Sender: TObject);
begin
  try
    CargarEstadoForm(Self);   // Esto es por si se ejecuta desde CD...
    CargarConfiguracionEditor;
    CargarConfiguracionSintaxis;
    CargarConfiguracionPrevisualizacionImpresion;
    CargarConfiguracionOracle;
    CargarConfiguracionProgramasFavoritos;
    CargarConfiguracionMenuFavoritos;
    CargarConfiguracionPlantillas;
    SpdBtnEditarPlantilla.Enabled := false;
    SpdBtnEliminarPlantilla.Enabled := false;
//    if Assigned(FrmPrincipal.ActiveMDIChild) then
      ConfigSynEditDefecto(SynEditCodigoPlantillas);    
{      with SynEditCodigoPlantillas do
      begin
        Highlighter := DMGlobal.SynSQLSyn;
        if ChkBxHome.Checked then
          Options               := Options + [eoEnhanceHomeKey]
        else
          Options               := Options - [eoEnhanceHomeKey];

        if ChkBxTab.Checked then
          Options               := Options + [eoSmartTabs]
        else
          Options               := Options - [eoSmartTabs];
        TabWidth                := SpnEdtTab.Value;
      end;}

      ConfigSynEditDefecto(SynEdit);
{      with SynEdit do
      begin
        Enabled := false;
        Highlighter := DMGlobal.SynSQLSyn;
        if ChkBxHome.Checked then
          Options               := Options + [eoEnhanceHomeKey]
        else
          Options               := Options - [eoEnhanceHomeKey];

        if ChkBxTab.Checked then
          Options               := Options + [eoSmartTabs]
        else
          Options               := Options - [eoSmartTabs];
        TabWidth                := SpnEdtTab.Value;
        WantTabs                := true;
      end;}
  except
  end;
end;

procedure TFrmConfiguracion.CargarLineasConsulta(Path: String; SE: TSynEdit);
var
  Ini : TIniFile;
  i   : Integer;
begin
  Ini := TIniFile.Create(Path);
  SE.Clear;
  for i := 0 to Ini.ReadInteger('INFO', 'Lineas', 0) do
  begin
//    showmessage(QuotedStr(Ini.ReadString('SQL', IntToStr(i), '')));
    SE.Lines.Add(Ini.ReadString('SQL', IntToStr(i), ''));
  end;
  Ini.Free;
end;

procedure TFrmConfiguracion.TrVwConsultaDDClick(Sender: TObject);
var
  Str : String;
begin
  if TrVwConsultaDD.Selected <> nil then
  begin
    EdtTituloConsultaDD.Text := TrVwConsultaDD.Selected.Text;
    Titulo := EdtTituloConsultaDD.Text;

    LblSentencia.Enabled  := TrVwConsultaDD.Selected.ImageIndex = 1;
    SynEdit.Enabled       := TrVwConsultaDD.Selected.ImageIndex = 1;
    SpdBtnNuevoSubDirFav.Enabled  := TrVwConsultaDD.Selected.ImageIndex <> 1;
    SpdBtnNuevoSubItemFav.Enabled := TrVwConsultaDD.Selected.ImageIndex <> 1;    
    if SynEdit.Enabled then
    begin
      ActiveControl := SynEdit;
      Str := ObtenerPathTreeView;
//      if FileExists(ExtractFilePath(ParamStr(0)) + 'Favoritos\' + Str) then
      CargarLineasConsulta(ExtractFilePath(ParamStr(0)) + 'Favoritos\' + Str, SynEdit);
    end;
  end;
end;

procedure TFrmConfiguracion.EdtTituloConsultaDDChange(Sender: TObject);
begin
  if TrVwConsultaDD.Selected <> nil then
  begin
    TrVwConsultaDD.Selected.Text := EdtTituloConsultaDD.Text;
    SpdBtnCambiarFav.Enabled := true;
  end;
end;

procedure TFrmConfiguracion.SpdBtnNuevoItemFavClick(Sender: TObject);
var
  IdPadre : Integer;
begin
  with TrVwConsultaDD do
  begin
    if Selected <> nil then
    begin
      if Selected.Parent.Index <> -1 then
      begin
        IdPadre := Selected.Parent.AbsoluteIndex;
      end;
{      TrVwConsultaDDInv.Selected := TrVwConsultaDDInv.Items[Selected.AbsoluteIndex];
      TrVwConsultaDDInv.Items.Add(TrVwConsultaDDInv.Selected, '-');}
      Selected := Items.Add(Selected, '-');
//      ShowMessage(IntToStr(IdPadre) {+ '; Inv ' + IntToStr(TrVwConsultaDDInv.Items[IdPadre].Index)});
    end
    else
      if Items.Count = 0 then // No hay items, aado el primero (padre de todos).
      begin
        Selected := Items.Add(nil, '-');
//        TrVwConsultaDDInv.Items.Add(nil, '-');
      end;
    if Selected <> nil then
    begin
      SynEdit.Clear;
      Selected.ImageIndex := 1;
    end;
  end; // with
  TrVwConsultaDDClick(nil);
  EdtTituloConsultaDD.Clear;
  ActiveControl := EdtTituloConsultaDD;
end;

procedure TFrmConfiguracion.SpdBtnNuevoSubItemFavClick(Sender: TObject);
var
  IdPadre : Integer;
begin
  with TrVwConsultaDD do
    if Selected <> nil then
    begin
      IdPadre := Selected.AbsoluteIndex;
      Selected := Items.AddChild(Selected, '-');
      Selected.ImageIndex := 1;
      TrVwConsultaDDClick(nil);
      EdtTituloConsultaDD.Clear;
      ActiveControl := EdtTituloConsultaDD;
    end;
end;

procedure TFrmConfiguracion.SpdBtnEliminarFavClick(Sender: TObject);
var
  IdEliminado : Integer;
  Path : String;
begin
  if TrVwConsultaDD.Selected <> nil then
  begin
    Path := ExtractFilePath(ExtractFilePath(ParamStr(0)) + PathFavoritos + PathDelim + ObtenerPathTreeView) ;
    if not TrVwConsultaDD.Selected.HasChildren then
    begin
      DeleteFile(Path + TrVwConsultaDD.Selected.Text);
      IdEliminado := TrVwConsultaDD.Selected.AbsoluteIndex;
      TrVwConsultaDD.Selected.Delete;
    end
    else
      if MessageDlg('Ests seguro?', mtWarning, mbOKCancel, 0) = mrOk then
      begin
        BorrarTodo(Path + TrVwConsultaDD.Selected.Text);
        IdEliminado := TrVwConsultaDD.Selected.AbsoluteIndex;
        TrVwConsultaDD.Selected.Delete;
      end;
  end;
//  EdtTituloConsultaDD.Clear;
end;

procedure TFrmConfiguracion.ActAbrirProgramaAccept(Sender: TObject);
var
   Icono  : TIcon;
   Indice : word;
   Cmp    : TComponent;
begin
  Icono := TIcon.Create;
  // Indice del icono a extraer
  Indice := 0;
  Icono.handle := ExtractAssociatedIcon(hInstance,
                                        Pchar(ActAbrirPrograma.Dialog.FileName), Indice);
(*  Image1.Picture.Bitmap.Width:= Icono.Width;
  Image1.Picture.Bitmap.Height:= Icono.Height;
  Image1.Picture.Bitmap.Canvas.Draw(0,0,Icono);*)
  if Sender is TSpeedButton then
    ShowMessage('ok');
{  with TSpeedButton(Sender) do
  begin
    ShowMessage(Sender.ClassName);
    Glyph.Width := Icono.Width;
    Glyph.Height := Icono.Height;
    Glyph.Canvas.Draw(0, 0, Icono);
  end;}
  Cmp := FindComponent('LblPrograma' + IntToStr(TSpeedButton(Sender).Tag));
  if Assigned(Cmp) then
    TLabel(Cmp).Caption := ActAbrirPrograma.Dialog.FileName;
  Icono.Free;
end;

procedure TFrmConfiguracion.SpdBtnPrograma1Click(Sender: TObject);
var
   Icono  : TIcon;
   Bitmap : TBitmap;
   Indice : word;
   Cmp    : TComponent;
begin
  // DONE: Aqui esta el fallo
  Icono := TIcon.Create;
  try
    // Indice del icono a extraer
    Indice := 10;
    OpenDialog.Filter := 'Ejecutables (*.EXE)|*.EXE|Cualquier fichero (*.*)|*.*';
    if OpenDialog.Execute then
    begin
//      ImgIcono.Picture.Icon.Handle
      Icono.handle := ExtractAssociatedIcon(hInstance, Pchar(OpenDialog.FileName),
                                            Indice);
      ImgIcono.Picture.Icon.Handle := Icono.Handle;
      ImgIcono.Width := 16;
      ImgIcono.Height := 16;
(*      Image1.Picture.Bitmap.Width:= Icono.Width;
      Image1.Picture.Bitmap.Height:= Icono.Height;
      Image1.Picture.Bitmap.Canvas.Draw(0,0,Icono);*)
      with TSpeedButton(Sender) do
      begin
//        ImgIcono.Picture.Icon.Canvas.Draw(0, 0, Icono);
(*        Bitmap := TBitmap.Create;
        Bitmap.Width := 16;
        Bitmap.Height := 16;
        Bitmap.
        Bitmap.Canvas.Draw(0, 0, Icono);*)
        Glyph.Width := ImgIcono.Width;
        Glyph.Height := ImgIcono.Height;
        Glyph.Canvas.Draw(0, 0, ImgIcono.Picture.Icon);
//        Bitmap.Free;
      end;
      Cmp := FindComponent('LblPrograma' + IntToStr(TSpeedButton(Sender).Tag));
      if Assigned(Cmp) then
        TLabel(Cmp).Caption := OpenDialog.FileName;// ActAbrirPrograma.Dialog.FileName;
    end;
  finally
    Icono.Free;
  end;
end;

procedure TFrmConfiguracion.ChkBxConectarAutomaticamenteClick(
  Sender: TObject);
begin
  if ChkBxConectarAutomaticamente.Checked then
    ChkBxConectarAutomaticamenteSesion.Checked := false;
end;

procedure TFrmConfiguracion.ChkBxConectarAutomaticamenteSesionClick(
  Sender: TObject);
begin
  if ChkBxConectarAutomaticamenteSesion.Checked then
    ChkBxConectarAutomaticamente.Checked := false;
end;

procedure TFrmConfiguracion.LstVwTitulosPlantillasSelectItem(
  Sender: TObject; Item: TListItem; Selected: Boolean);
var
  i, Indice, Tope : Integer;
//  Editor  : TFrmEditor;
  Linea   : String;
begin
{  if FrmPrincipal.MDIChildCount = 0 then
    Exit;}

  SpdBtnEditarPlantilla.Enabled            := true;
  SpdBtnEliminarPlantilla.Enabled          := true;
  SynEditCodigoPlantillas.Enabled := true;

  if Assigned(LstVwTitulosPlantillas.Selected) then
  begin
//    Editor := TFrmEditor(FrmPrincipal.ActiveMDIChild);
    SynEditCodigoPlantillas.ClearAll;
    Indice := LstVwTitulosPlantillas.Selected.Index;
    if DMGlobal.SynAutoComplete.CompletionValues[indice] <> '' then
    begin
      Tope := GetTokenCount(DMGlobal.SynAutoComplete.CompletionValues[indice], #13) - 1;
      for i := 0 to Tope do
      begin
        Linea := GetToken(DMGlobal.SynAutoComplete.CompletionValues[indice], #13, i + 1);
        if (Linea <> '') and  not (Linea[Length(Linea)] in [#13, #10]) then
          SynEditCodigoPlantillas.Lines.Add(CambiaEn(Linea, #10, ''));
      end;
    end;
  end;
  // Un algoritmo un tanto enrrevesado... :-)
end;

function Texto: String;
var
  i : integer;
begin
  Result := '';
  for i := 0 to DMGlobal.SynAutoComplete.AutoCompleteList.Count - 1 do
    Result := Result + #13 + '[' + IntToStr(i) + '] ' +
      DMGlobal.SynAutoComplete.AutoCompleteList[i];
end;

//procedure TFrmConfiguracion.BuscarRango(Cabecera: String; var IComienzo, IFin: Integer);
procedure TFrmConfiguracion.BuscarRango(Item: TListItem; var IComienzo, IFin: Integer);
var
  Cabecera, CabeceraSig : String;
begin
  Cabecera := Format('[%s | %s]', [LstVwTitulosPlantillas.Selected.Caption,
                     LstVwTitulosPlantillas.Selected.SubItems[0]]);
  IComienzo := DMGlobal.SynAutoComplete.AutoCompleteList.IndexOf(Cabecera);


  if LstVwTitulosPlantillas.Items.Count = LstVwTitulosPlantillas.Selected.Index + 1 then
  begin       // Si es el ltimo
    IFin := DMGlobal.SynAutoComplete.AutoCompleteList.Count - 1;
  end
  else begin  // Si no es el ltimo, busco el ndice del siguiente
    CabeceraSig := Format('[%s | %s]', [LstVwTitulosPlantillas.Items[LstVwTitulosPlantillas.Selected.Index + 1].Caption,
                          LstVwTitulosPlantillas.Items[LstVwTitulosPlantillas.Selected.Index + 1].SubItems[0]]);
    IFin := DMGlobal.SynAutoComplete.AutoCompleteList.IndexOf(CabeceraSig) - 1;
  end;
end;

procedure TFrmConfiguracion.SynEditCodigoPlantillasChange(Sender: TObject);
var
  i, ISeleccionado, IPlantilla, ISiguiente : Integer;
//  Editor  : TFrmEditor;
  Plantilla, Cabecera : String;
begin
{  if FrmPrincipal.MDIChildCount = 0 then
    Exit;}

  if Assigned(LstVwTitulosPlantillas.Selected) then
  begin
//    Editor := TFrmEditor(FrmPrincipal.ActiveMDIChild);
    ISeleccionado := LstVwTitulosPlantillas.Selected.Index;
    for i := 0 to SynEditCodigoPlantillas.Lines.Count - 1 do
      Plantilla := Plantilla + SynEditCodigoPlantillas.Lines[i] + #13 + #10;
(*
    IPlantilla := Editor.SynAutoComplete.AutoCompleteList.IndexOf(
      Format('[%s | %s]', [LstVwTitulosPlantillas.Selected.Caption,
      LstVwTitulosPlantillas.Selected.SubItems[0]]));

    ISiguiente := 0;
    for i := IPlantilla + 1 to Editor.SynAutoComplete.AutoCompleteList.Count - 1 do
    begin
      Cabecera := Editor.SynAutoComplete.AutoCompleteList[i];
      if (Cabecera <> '') and (Cabecera[1] = '[') and
         (Cabecera[Length(Cabecera)] = ']') then
        ISiguiente := i - 1;
    end;
    if ISiguiente = 0 then
      ISiguiente := Editor.SynAutoComplete.AutoCompleteList.Count - 1;
*)
{    BuscarRango(Format('[%s | %s]', [LstVwTitulosPlantillas.Selected.Caption,
    LstVwTitulosPlantillas.Selected.SubItems[0]]), IPlantilla, ISiguiente);}
    BuscarRango(LstVwTitulosPlantillas.Selected, IPlantilla, ISiguiente);

{
    ShowMessage('IPlantilla = ' + IntToStr(IPlantilla) + #13 +
                'ISiguiente = ' + IntToStr(ISiguiente) + #13 +
                'Desde = ' + IntToStr(IPlantilla) + #13 +
                'Hasta = ' + IntToStr(ISiguiente) + #13 +
                'Inicio: ' + #13 + Texto);
}
    for i := IPlantilla + 1 to ISiguiente do
      DMGlobal.SynAutoComplete.AutoCompleteList.Delete(IPlantilla + 1);
//    ShowMessage('Eliminacin: ' + #13 + Texto);

    for i := 0 to SynEditCodigoPlantillas.Lines.Count - 1 do
      DMGlobal.SynAutoComplete.AutoCompleteList.Insert(IPlantilla + 1 + i, SynEditCodigoPlantillas.Lines[i]);
    DMGlobal.SynAutoComplete.AutoCompleteList.Insert(IPlantilla + 1 + i, '');
{
    ShowMessage('IPlantilla = ' + IntToStr(IPlantilla) + #13 +
                'ISiguiente = ' + IntToStr(ISiguiente) + #13 +
                'Aadir: ' + #13 + Texto);
}
//    ShowMessage(Format('[ %s | %s ]', [LstVwTitulosPlantillas.Selected.Caption, LstVwTitulosPlantillas.Selected.SubItems[0]]));
//    ShowMessage('[0] ' + Editor.SynAutoComplete.AutoCompleteList[0]);
//    ShowMessage(Editor.SynAutoComplete.CompletionValues[Indice]);
    DMGlobal.SynAutoComplete.AddCompletion(LstVwTitulosPlantillas.Items[ISeleccionado].Caption,
                                         Plantilla, LstVwTitulosPlantillas.Items[ISeleccionado].SubItems[0]);
{    Editor.SynAutoComplete.Completions[Indice] :=
      Format('[ %s | %s ]', LstVwTitulosPlantillas.Items[Indice].Caption, Plantilla;}
  end;
end;

procedure TFrmConfiguracion.SpdBtnEditarPlantillaClick(Sender: TObject);
var
  i : Integer;
begin
  with FrmCabeceraPlantilla do
  begin
    EdtNombre.Text := LstVwTitulosPlantillas.Selected.Caption;
    EdtDescripcion.Text := LstVwTitulosPlantillas.Selected.SubItems[0];
    if ShowModal = mrOk then
    begin
      i := DMGlobal.SynAutoComplete.AutoCompleteList.IndexOf(
        Format('[%s | %s]', [FrmConfiguracion.LstVwTitulosPlantillas.Selected.Caption,
                             FrmConfiguracion.LstVwTitulosPlantillas.Selected.SubItems[0]]));
      DMGlobal.SynAutoComplete.AutoCompleteList[i] :=
        Format('[%s | %s]', [EdtNombre.Text, EdtDescripcion.Text]);
      LstVwTitulosPlantillas.Selected.Caption := EdtNombre.Text;
      LstVwTitulosPlantillas.Selected.SubItems[0] := EdtDescripcion.Text;
{  FrmConfiguracion.LstVwTitulosPlantillasSelectItem(Self,
    FrmConfiguracion.LstVwTitulosPlantillas.Selected, true);}
    end;
  end;
end;

procedure TFrmConfiguracion.SpdBtnAniadirPlantillaClick(Sender: TObject);
var
  i : Integer;
begin
  with FrmCabeceraPlantilla do
  begin
    EdtNombre.Clear;
    EdtDescripcion.Clear;
    if ShowModal = mrOk then
    begin
      i := LstVwTitulosPlantillas.Items.Add.Index;
      LstVwTitulosPlantillas.Items[i].Caption := EdtNombre.Text;
      LstVwTitulosPlantillas.Items[i].SubItems.Add(EdtDescripcion.Text);
      LstVwTitulosPlantillas.Selected := nil;
      LstVwTitulosPlantillas.OnSelectItem := nil;
      LstVwTitulosPlantillas.Selected := LstVwTitulosPlantillas.Items[i];
      LstVwTitulosPlantillas.Update;
      LstVwTitulosPlantillas.OnSelectItem := LstVwTitulosPlantillasSelectItem;
      DMGlobal.SynAutoComplete.AutoCompleteList.Add(
        Format('[%s | %s]', [EdtNombre.Text, EdtDescripcion.Text]));
      LstVwTitulosPlantillas.Scroll(LstVwTitulosPlantillas.Selected.Position.X, LstVwTitulosPlantillas.Selected.Position.Y);
      LstVwTitulosPlantillasSelectItem(LstVwTitulosPlantillas, LstVwTitulosPlantillas.Items[i], true);
      //TODO: Pasar el foco al SynEditCodigoPlantillas
//      ActiveControl := SynEditCodigoPlantillas;
//--      DMGlobal.SynAutoComplete.AutoCompleteList.SaveToFile();
//      TFrmEditor(FrmPrincipal.ActiveMDIChild).SynAutoComplete.AutoCompleteList.Add('');        

{      TFrmEditor(FrmPrincipal.ActiveMDIChild).SynAutoComplete.AddCompletion(
        EdtNombre.Text, 'autocompletado', EdtDescripcion.Text);}

{      i := TFrmEditor(FrmPrincipal.ActiveMDIChild).SynAutoComplete.AutoCompleteList.IndexOf(
        Format('[%s | %s]', [FrmConfiguracion.LstVwTitulosPlantillas.Selected.Caption,
                             FrmConfiguracion.LstVwTitulosPlantillas.Selected.SubItems[0]]));
      TFrmEditor(FrmPrincipal.ActiveMDIChild).SynAutoComplete.AutoCompleteList[i] :=
        Format('[%s | %s]', [EdtNombre.Text, EdtDescripcion.Text]);
      LstVwTitulosPlantillas.Selected.Caption := EdtNombre.Text;
      LstVwTitulosPlantillas.Selected.SubItems[0] := EdtDescripcion.Text;}
{  FrmConfiguracion.LstVwTitulosPlantillasSelectItem(Self,
    FrmConfiguracion.LstVwTitulosPlantillas.Selected, true);}
    end;
  end;
end;

procedure TFrmConfiguracion.SpdBtnEliminarPlantillaClick(Sender: TObject);
var
  i, IPlantilla, ISiguiente : Integer;
//  Editor  : TFrmEditor;
begin
{  if FrmPrincipal.MDIChildCount = 0 then
    Exit;}

//  Editor := TFrmEditor(FrmPrincipal.ActiveMDIChild);
//  ShowMessage('' + #13 + Texto);
{  BuscarRango(Format('[%s | %s]', [LstVwTitulosPlantillas.Selected.Caption,
  LstVwTitulosPlantillas.Selected.SubItems[0]]), IPlantilla, ISiguiente);}
  BuscarRango(LstVwTitulosPlantillas.Selected, IPlantilla, ISiguiente);
//  ShowMessage('IPlantilla = ' + IntToStr(IPlantilla) + ' ISiguiente = ' + IntToStr(ISiguiente) + #13 + Texto);
  for i := IPlantilla to ISiguiente do
    DMGlobal.SynAutoComplete.AutoCompleteList.Delete(IPlantilla);
//  Editor.SynAutoComplete.AutoCompleteList.Insert(IPlantilla + 1 + i, '');
  LstVwTitulosPlantillas.Selected.Delete;
  SynEditCodigoPlantillas.ClearAll;
  SpdBtnEliminarPlantilla.Enabled := false;
  SpdBtnEditarPlantilla.Enabled := false;
end;

procedure TFrmConfiguracion.BitBtnOkClick(Sender: TObject);
begin
  try
    if (RdGrpFormaConexion.ItemIndex = 2) and (EdtLogin.Text = '') then
      ShowMessage('Debe ingresar el login')
    else if (RdGrpFormaConexion.ItemIndex = 2) and (EdtPassword.Text = '') and (ChkBxGuardarIni.Checked) then
      ShowMessage('Debe ingresar el password')
    else begin
      AplicarConfiguracionEditor;
      GuardarConfiguracionEditor;
      AplicarConfiguracionSintaxis;
      GuardarConfiguracionSintaxis;
      AplicarConfiguracionPrevisualizacionImpresion;
      GuardarConfiguracionPrevisualizacionImpresion;
      AplicarConfiguracionOracle;
      GuardarConfiguracionOracle;
      AplicarConfiguracionProgramasFavoritos;
      GuardarConfiguracionProgramasFavoritos;
//      AplicarConfiguracionMenuDD;
//      GuardarConfiguracionMenuDD;
      GuardarConfiguracionPlantillas;

      // Actualizamos el men de favoritos (por si ha tocado algo)
      CargarConfiguracionMenuFavoritos;
      
      Close;
    end;
  except
  end;
end;

procedure TFrmConfiguracion.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  try
    GuardarEstadoForm(Self);
  except
  end;
end;

procedure TFrmConfiguracion.SynEditKeyPress(Sender: TObject;
  var Key: Char);
begin
  SpdBtnAplicarFav.Enabled := true;
end;


function TFrmConfiguracion.ObtenerPathTreeView: String;
var
  Temp    : TTreeNode;
  Salir   : Boolean;
begin
  Temp := TrVwConsultaDD.Selected;//.GetPrev;
  Result := '';
  Salir := false;
  while Assigned(Temp) and (not Salir) do
  begin
    Result := Temp.Text + '\' + Result;
    Salir := Temp.Level = 0;
    Temp := Temp.Parent;
  end;
  SetLength(Result, Length(Result) - 1);
//  ShowMessage('ObtenerPathTreeView:'#13 + Result);
end;

procedure TFrmConfiguracion.SpdBtnAplicarFavClick(Sender: TObject);
var
  Ini   : TIniFile;
  i     : Integer;
  Str   : String;
begin
  // Obtenemos la jerarqua de directorios en la cadena Str
  Str := ObtenerPathTreeView;

  // Concatenamos el directorio de los favoritos
  Str := ExtractFilePath(ParamStr(0)) + 'Favoritos\' + Str;

  // Creamos la estructura de directorios
  ForceDirectories(ExtractFilePath(Str));

  // Si existe lo borramos (no se porque pero hay que hacerlo, no se sobreescribe...)
  if FileExists(Str) then
    DeleteFile(Str);

  // Finalmente, creamos el fichero
  Ini := TIniFile.Create(Str);
  Ini.WriteString('INFO', 'Titulo', TrVwConsultaDD.Selected.Text);
  Ini.WriteInteger('INFO', 'Lineas', SynEdit.Lines.Count);
  for i := 0 to SynEdit.Lines.Count - 1 do
    Ini.WriteString('SQL', IntToStr(i), SynEdit.Lines[i]);
  Ini.Free;

{  // Actualizamos el men de favoritos
  CargarConfiguracionMenuDD;}
  SpdBtnAplicarFav.Enabled := false;
end;

function ObtenerPathTreeView2(Nodo: TTreeNode): String;
var
  Temp    : TTreeNode;
  Salir   : Boolean;
begin
  Temp := Nodo;//.GetPrev;
  Result := '';
  Salir := false;
  while Assigned(Temp) and (not Salir) do
  begin
    Result := Temp.Text + '\' + Result;
    Salir := Temp.Level = 0;
    Temp := Temp.Parent;
  end;
  SetLength(Result, Length(Result) - 1);
//  ShowMessage('ObtenerPathTreeView:'#13 + Result);
end;

procedure TFrmConfiguracion.TrVwConsultaDDGetImageIndex(Sender: TObject;
  Node: TTreeNode);
var
  Path  : String;
begin
  Path := ExtractFilePath(ExtractFilePath(ParamStr(0)) + PathFavoritos + PathDelim + ObtenerPathTreeView2(Node)) + Node.Text;
  if Node.ImageIndex = 1 then // MUY RARO, pero si no se pone, no funciona.
    Node.ImageIndex := 1
  else if Node.ImageIndex = 0 then
    Node.ImageIndex := 0
  else if DirectoryExists(Path) then
//  if Node.HasChildren then
    if Node.Expanded then
      Node.ImageIndex := 3
    else
      Node.ImageIndex := 0
  else //if FileExists(Path) then
    Node.ImageIndex := 1;
end;

procedure TFrmConfiguracion.TrVwConsultaDDGetSelectedIndex(Sender: TObject;
  Node: TTreeNode);
begin
  Node.SelectedIndex := Node.ImageIndex;
end;

procedure TFrmConfiguracion.TrVwConsultaDDCompare(Sender: TObject; Node1,
  Node2: TTreeNode; Data: Integer; var Compare: Integer);
begin
  if (Node1.ImageIndex in [0, 3]) and (Node2.ImageIndex = 1) then
    Compare := -1
  else if (Node1.ImageIndex = 1) and (Node2.ImageIndex in [0, 3]) then
    Compare := 1
  else
    Compare := CompareText(Node1.Text, Node2.Text);
end;

procedure TFrmConfiguracion.SpdBtnExpandirFavClick(Sender: TObject);
var
  i : Integer;
begin
  for i := 0 to TrVwConsultaDD.Items.Count -1 do
    TrVwConsultaDD.Items[i].Expand(true);
end;

procedure TFrmConfiguracion.SpdBtnContraerFavClick(Sender: TObject);
var
  i : Integer;
begin
  for i := 0 to TrVwConsultaDD.Items.Count -1 do
    TrVwConsultaDD.Items[i].Collapse(true);
end;

procedure TFrmConfiguracion.TrVwConsultaDDDragDrop(Sender, Source: TObject;
  X, Y: Integer);
var
  AnItem: TTreeNode;
  AttachMode: TNodeAttachMode;
  HT: THitTests;
begin
{  if TrVwConsultaDD.Selected = nil then
    Exit;

  HT := TrVwConsultaDD.GetHitTestInfoAt(X, Y);
  AnItem := TrVwConsultaDD.GetNodeAt(X, Y);
  if (HT - [htOnItem, htOnIcon, htNowhere, htOnIndent] <> HT) then
  begin
    if (htOnItem in HT) or (htOnIcon in HT) then
      AttachMode := naAddChild
    else if htNowhere in HT then
      AttachMode := naAdd
    else if htOnIndent in HT
      then AttachMode := naInsert;
    TrVwConsultaDD.Selected.MoveTo(AnItem, AttachMode);
  end;}
end;

procedure TFrmConfiguracion.Pegar1Click(Sender: TObject);
begin
  SynEdit.PasteFromClipboard;
  SpdBtnAplicarFav.Enabled := true;
end;

procedure TFrmConfiguracion.SpdBtnDocumentacionClick(Sender: TObject);
var
  Filtro  : String;
begin
  Filtro := OpenDialog.Filter;
  OpenDialog.Filter := 'Pginas web (*.html)|*.html;*.htm';
  if OpenDialog.Execute then
    LblDocumentacion.Caption := OpenDialog.FileName;
  OpenDialog.Filter := Filtro;
end;

// TODO: Menu popup para el tamao de fuente en el editor y el grid
procedure TFrmConfiguracion.SpdBtnCambiarFavClick(Sender: TObject);
var
  Path : String;
begin
  Path := ExtractFilePath(ExtractFilePath(ParamStr(0)) + PathFavoritos + PathDelim + ObtenerPathTreeView) ;
  if not TrVwConsultaDD.Selected.HasChildren then // es un fichero
  begin
    RenameFile(Path + Titulo, Path + EdtTituloConsultaDD.Text);
  end
  else begin
    // mmmmm, no se como renombrar un directorio, asi que lo que hay
    // que hacer es crear el nuevo directorio, copiar todo su contenido
    // y finalmente borrar el antiguo
    ForceDirectories(Path + EdtTituloConsultaDD.Text);
    CopiaTodo(Path + Titulo + '\*.*', Path + EdtTituloConsultaDD.Text);
    BorrarTodo(Path + Titulo);
  end;
  SpdBtnCambiarFav.Enabled := false;
end;

procedure TFrmConfiguracion.PageControlChange(Sender: TObject);
begin
  if PageControl.ActivePage = TbShtFavoritos then
  begin
    BitBtnCancelar.Visible := false;
    TrVwConsultaDD.Update;
    TrVwConsultaDD.AlphaSort(true);
  end;
end;

procedure TFrmConfiguracion.SpdBtnNuevoDirFavClick(Sender: TObject);
var
  IdPadre : Integer;
begin
  with TrVwConsultaDD do
  begin
    if Selected <> nil then
    begin
      if Selected.Parent.Index <> -1 then
      begin
        IdPadre := Selected.Parent.AbsoluteIndex;
      end;
{      TrVwConsultaDDInv.Selected := TrVwConsultaDDInv.Items[Selected.AbsoluteIndex];
      TrVwConsultaDDInv.Items.Add(TrVwConsultaDDInv.Selected, '-');}
      Selected := Items.Add(Selected, '-');
//      ShowMessage(IntToStr(IdPadre) {+ '; Inv ' + IntToStr(TrVwConsultaDDInv.Items[IdPadre].Index)});
    end
    else
      if Items.Count = 0 then // No hay items, aado el primero (padre de todos).
      begin
        Selected := Items.Add(nil, '-');
//        TrVwConsultaDDInv.Items.Add(nil, '-');
      end;
    if Assigned(Selected) then
      Selected.ImageIndex := 0;
  end; // with
  TrVwConsultaDDClick(nil);  
  EdtTituloConsultaDD.Clear;
  ActiveControl := EdtTituloConsultaDD;
end;

procedure TFrmConfiguracion.SpdBtnNuevoSubDirFavClick(Sender: TObject);
var
  IdPadre : Integer;
begin
  with TrVwConsultaDD do
    if Selected <> nil then
    begin
      IdPadre := Selected.AbsoluteIndex;
//      if Selected.
      Selected := Items.AddChild(Selected, '-');
//      TrVwConsultaDDInv.Items.AddChild(TrVwConsultaDDInv.Items[IdPadre], '-');
      Selected.ImageIndex := 0;
      TrVwConsultaDDClick(nil);      
      EdtTituloConsultaDD.Clear;
      ActiveControl := EdtTituloConsultaDD;
    end;
end;

procedure TFrmConfiguracion.TrVwConsultaDDKeyDown(Sender: TObject;
  var Key: Word; Shift: TShiftState);
begin
  if Key = VK_DELETE then
    SpdBtnEliminarFav.Click
  else if Key = VK_ADD then
    SpdBtnExpandirFav.Click
  else if Key = VK_SUBTRACT	then
    SpdBtnContraerFav.Click;
end;

procedure TFrmConfiguracion.RdGrpFormaConexionClick(Sender: TObject);
begin
  if RdGrpFormaConexion.ItemIndex = 2 then
  begin
    LblLogin.Enabled    := true;
    LblPassword.Enabled := true;
    EdtLogin.Enabled    := true;
    EdtPassword.Enabled := true;
    ChkBxGuardarIni.Enabled := true;
  end
  else begin
    LblLogin.Enabled    := false;
    LblPassword.Enabled := false;
    EdtLogin.Enabled    := false;
    EdtPassword.Enabled := false;
    ChkBxGuardarIni.Enabled := false;
  end;
end;

procedure TFrmConfiguracion.ChkBxGuardarIniClick(Sender: TObject);
begin
  if ChkBxGuardarIni.Checked then
  begin
    LblPassword.Enabled := true;
    EdtPassword.Enabled := true;
  end
  else begin
    EdtPassword.Clear;
    LblPassword.Enabled := false;
    EdtPassword.Enabled := false;
  end;
end;

procedure TFrmConfiguracion.PpMnuSynEditDefectoPopup(Sender: TObject);
begin
//  ShowMessage('POPUP = ' + TComponent(PopUpMenu1.PopupComponent).Name);
end;

procedure TFrmConfiguracion.SynEditStatusChange(Sender: TObject;
  Changes: TSynStatusChanges);
begin
  if scModified in Changes then
    SpdBtnAplicarFav.Enabled := true;
end;

procedure TFrmConfiguracion.SynEditChange(Sender: TObject);
begin
  SpdBtnAplicarFav.Enabled := true;
end;

procedure TFrmConfiguracion.SpdBtnLimpiarClick(Sender: TObject);
begin
  SynEdit.ClearAll;
end;

end.

// 2062
