////////////////////////////////////////////////////////////////////////////////
//
// Proyecto Medusa v3.0
//
//////////////////////////////////// INFO //////////////////////////////////////
//
//  Nombre del programa : Medusa.exe
//  Fecha               : Septiembre del 2003.
//  Componentes         : DOA 3.4.6.4, SynEdit 1.1 (CVS).
//  Version compilador  : Delphi 6.0 Enterprise.
//  Descripcin         : Un cliente avanzado de Oracle
//  Autor               : Albert Philippe De La Fuente Vigliotti.
//  Tutor               : Jos Galindo Gmez.
//
////////////////////////////////////////////////////////////////////////////////

unit UFormatosFecha;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, Buttons;

type
  TFrmFormatoFechas = class(TForm)
    Label2: TLabel;
    EdtFormato: TEdit;
    LstVwElems: TListView;
    Label5: TLabel;
    SpdBtnCopiar: TSpeedButton;
    BitBtnCancelar: TBitBtn;
    BitBtnOk: TBitBtn;
    procedure LstVwExprSelectItem(Sender: TObject; Item: TListItem;
      Selected: Boolean);
    procedure EdtPreExprChange(Sender: TObject);
    procedure SpdBtnAniadirClick(Sender: TObject);
    procedure SpdBtnEliminarClick(Sender: TObject);
    procedure LstVwElemsChange(Sender: TObject; Item: TListItem;
      Change: TItemChange);
    procedure SpdBtnCopiarClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure SpdBtnLimpiarClick(Sender: TObject);
    procedure LstVwElemsDblClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FrmFormatoFechas: TFrmFormatoFechas;

implementation

uses UGlobal;

{$R *.dfm}

procedure TFrmFormatoFechas.LstVwExprSelectItem(Sender: TObject; Item: TListItem;
  Selected: Boolean);
var
  Str         : String;
  Encontrado  : Boolean;
  i           : Integer;
begin
{  if Item.SubItems.Count <> 0 then
  begin}
{  if Selected then
  begin
    EdtPreExpr.OnChange   := nil;
//    CmBxElemento.OnChange := nil;
    LstVwElems.OnChange   := nil;
    EdtPostExpr.OnChange  := nil;
    if Item.SubItems[0] = '''' then
      EdtPreExpr.Text       := ''
    else
      EdtPreExpr.Text       := Copy(Item.SubItems[0], 2, Length(Item.SubItems[0]) - 2);

//    CmBxElemento.Text     := Copy(Item.SubItems[1], 2, Length(Item.SubItems[1]) - 1);

    // Localizamos el elemento de la lista y lo marcamos
    Str := Item.SubItems[1];
    i := 0;
    Encontrado := false;
    while (i <= LstVwElems.Items.Count - 1) and (not Encontrado) do
    begin
      Encontrado := LstVwElems.Items[i].Caption = Str;
      inc(i);
    end;
    if i <= LstVwElems.Items.Count - 1 then
    begin
//      LstVwElems.ItemIndex := i - 1;
      LstVwElems.Selected := nil;
      LstVwElems.Selected := LstVwElems.Items[i - 1]; //.Selected := true; //LstVwElems.Items..IndexOf();
    end;

    if EdtPostExpr.Text = '''' then
      EdtPostExpr.Text      := ''
    else
      EdtPostExpr.Text      := Copy(Item.SubItems[2], 2, Length(Item.SubItems[2]) - 2);
    EdtPreExpr.OnChange   := EdtPreExprChange;
//    CmBxElemento.OnChange := EdtPreExprChange;
    LstVwElems.OnChange   := LstVwElemsChange;
    EdtPostExpr.OnChange  := EdtPreExprChange;
  end;
    if Item.SubItems[1] = '' then
      CmBxElemento.Text := 'Seleccionar...';
//  end;
  SpdBtnEliminar.Enabled := true;
//  end;}
end;

procedure TFrmFormatoFechas.EdtPreExprChange(Sender: TObject);
var
  i : Integer;
  PreExpr, PostExpr : String;
begin
{  with LstVwExpr do
  begin
    if Assigned(Selected) then
    begin
      Selected.SubItems[0] := QuotedStr(EdtPreExpr.Text);

      if Assigned(LstVwElems.Selected) then
        Selected.SubItems[1] := LstVwElems.Selected.Caption;

      Selected.SubItems[2] := QuotedStr(EdtPostExpr.Text);
    end;

    EdtFormato.Clear;
    for i := 0 to Items.Count - 1 do
    begin
      if Items[i].SubItems[0] = '''' then
        PreExpr   := ''
      else
        PreExpr   := Copy(Items[i].SubItems[0], 2, Length(Items[i].SubItems[0]) - 2);

      if Items[i].SubItems[2] = '''' then
        PostExpr  := ''
      else
        PostExpr  := Copy(Items[i].SubItems[2], 2, Length(Items[i].SubItems[2]) - 2);

      EdtFormato.Text := EdtFormato.Text + PreExpr + Items[i].SubItems[1] + PostExpr;
    end;
    EdtFormato.Text := QuotedStr(EdtFormato.Text);
  end;}
end;

procedure TFrmFormatoFechas.SpdBtnAniadirClick(Sender: TObject);
var
  Item  : TListItem;
begin
//  CmBxTipoArg.Text := 'Seleccionar...';
{  Item := LstVwExpr.Items.Add;
  Item.SubItems.Add('');
  Item.SubItems.Add('');
  Item.SubItems.Add('');
  LstVwExpr.OnSelectItem := nil;
  LstVwExpr.Selected := LstVwExpr.Items[LstVwExpr.Items.Count - 1];
  LstVwExpr.Selected.Caption := IntToStr(LstVwExpr.Selected.Index + 1);
  LstVwExpr.OnSelectItem := LstVwExprSelectItem;
  EdtPreExpr.Clear;
  EdtPostExpr.Clear;}  
end;

procedure TFrmFormatoFechas.SpdBtnEliminarClick(Sender: TObject);
var
  i : Integer;
begin
{  if Assigned(LstVwExpr.Selected) then
  begin
    LstVwExpr.Selected.Delete;
    for i := 0 to LstVwExpr.Items.Count - 1 do
      LstVwExpr.Items[i].Caption := IntToStr(i + 1);
  end;}
end;

procedure TFrmFormatoFechas.LstVwElemsChange(Sender: TObject;
  Item: TListItem; Change: TItemChange);
begin
//  EdtPreExpr.OnChange(Sender);
end;

procedure TFrmFormatoFechas.SpdBtnCopiarClick(Sender: TObject);
var
  Inicio  : Integer;
begin
  Inicio := EdtFormato.SelStart;
  EdtFormato.SelectAll;
  EdtFormato.CopyToClipboard;
  EdtFormato.SelLength := 0;
  EdtFormato.SelStart := Inicio;
end;

procedure TFrmFormatoFechas.FormActivate(Sender: TObject);
begin
  try
    CargarEstadoForm(Self);   // Esto es por si se ejecuta desde CD...
  except
  end;
end;

procedure TFrmFormatoFechas.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  try
    GuardarEstadoForm(Self);
  except
  end;  
end;

procedure TFrmFormatoFechas.SpdBtnLimpiarClick(Sender: TObject);
begin
{  LstVwExpr.Clear;
  EdtFormato.Clear;}
end;

procedure TFrmFormatoFechas.LstVwElemsDblClick(Sender: TObject);
var
  Temp1, Temp2  : String;
  Inicio        : Integer;
begin
  if Assigned(LstVwElems.Selected) then
  begin
    Inicio := EdtFormato.SelStart;
//    ShowMessage(IntToStr(EdtFormato.SelStart));
    Temp1 := Copy(EdtFormato.Text, 1, EdtFormato.SelStart);
    Temp2 := Copy(EdtFormato.Text, EdtFormato.SelStart + 1, Length(EdtFormato.Text));
    EdtFormato.Text := Temp1 + LstVwElems.Selected.Caption + Temp2;
    ActiveControl := EdtFormato;
//    ShowMessage(IntToStr(EdtFormato.SelStart));
    EdtFormato.SelStart := Inicio + Length(LstVwElems.Selected.Caption);
    EdtFormato.SelLength := 0;    
{    EdtFormato.SetSelTextBuf(PChar(LstVwElems.Selected.Caption));
    EdtFormato.SelectAll;
}
  end;
//  ShowMessage(EdtFormato.SelStart);
//  Copy(EdtFormato.Text, 1, EdtFormato.Cursor)
end;

end.

// 246
