////////////////////////////////////////////////////////////////////////////////
//
// Proyecto Medusa v3.0
//
//////////////////////////////////// INFO //////////////////////////////////////
//
//  Nombre del programa : Medusa.exe
//  Fecha               : Septiembre del 2003.
//  Componentes         : DOA 3.4.6.4, SynEdit 1.1 (CVS).
//  Version compilador  : Delphi 6.0 Enterprise.
//  Descripcin         : Un cliente avanzado de Oracle
//  Autor               : Albert Philippe De La Fuente Vigliotti.
//  Tutor               : Jos Galindo Gmez.
//
////////////////////////////////////////////////////////////////////////////////

unit USplash;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, ExtCtrls;

type
  TFrmSplash = class(TForm)
    PrgBr: TProgressBar;
    Panel1: TPanel;
    LblMedusa: TLabel;
    LblClienteAvanzado: TLabel;
    LblSQL: TLabel;
    LblPLSQL: TLabel;
    LblTriggers: TLabel;
    LblFunciones: TLabel;
    LblProcedimientos: TLabel;
    Timer: TTimer;
    Label1: TLabel;
    LblVersion: TLabel;
    procedure TimerTimer(Sender: TObject);
    procedure FormActivate(Sender: TObject);
  private
    { Private declarations }
  public
    Contador  : Integer;
    { Public declarations }
  end;


const
  Tiempo  = 10;

var
  FrmSplash: TFrmSplash;

implementation

uses UPrincipal, UGlobal;

{$R *.dfm}

procedure TFrmSplash.TimerTimer(Sender: TObject);
begin
  Inc(Contador);
  PrgBr.Position := Trunc((Contador / Tiempo) * 100);
  if Contador = Tiempo then
  begin
//    Application.MainForm := FrmPrincipal;
//    FrmPrincipal.ShowModal;
    Close;
  end;
end;

procedure TFrmSplash.FormActivate(Sender: TObject);
begin
  Contador := 0;
  LblVersion.Caption := 'Versin ' + GetAppInfo(ParamStr(0), 'FileVersion');
end;

end.

// 81

// 9919 (hasta aqu)
